program CD; { RTK 1988.3.3 }

{ Program bere s standardnega vhoda in pie na 
  standardni izhod.  Vsak vzorec je v svoji vrstici. }

  const m = 40;             { dolina zakasnilne vrste } 
  type VzorecT = integer;   { vzorena amplituda signala } 
 
  procedure PosljiVzorec(Vzorec: VzorecT); 
    begin WriteLn(Vzorec); end;
    
  function DobiVzorec(var Vzorec: VzorecT; var Pravilen: boolean): boolean; 
  var S: string; c: integer;
  begin
    if Eof then DobiVzorec := false
    else begin
      ReadLn(S); Val(S, Vzorec, c);
      Pravilen := c = 0; DobiVzorec := true;
    end; {if}
  end; {DobiVzorec}

var 
  Vrsta: array[1..m] of VzorecT; { zakasnilna vrsta } 
  Pravilen: boolean;     { ali je vzorec pravilen } 
  ZadnjiPrav: integer;   { indeks zadnjega dobrega vzorca v vrsti } 
  Utisaj: integer;       { utiati je treba toliko naslednjih vzorcev } 
  NaZacetku: integer;    { koliko niel je e ostalo v vrsti od inicializacije }
  i: integer; 
  k: real; 
begin
  ZadnjiPrav := m; Utisaj := 0; NaZacetku := m;
  for i := 1 to m do Vrsta[i] := 0; 
  repeat 
    if NaZacetku = 0 then PosljiVzorec(Vrsta[1])  { polji najstareji vzorec } 
    else NaZacetku := NaZacetku - 1;
    for i := 2 to m do Vrsta[i - 1] := Vrsta[i];  { pomakni vrsto } 
    if ZadnjiPrav > 1 then ZadnjiPrav := ZadnjiPrav - 1; 
    if not DobiVzorec(Vrsta[m], Pravilen) then break;
    if Pravilen then begin 
      if Utisaj > 0 then begin 
        { zaradi prejnje dalje napake postopno poveujemo jakost } 
        Vrsta[m] := Vrsta[m] * (30 - Utisaj + 1) div 31; 
        Utisaj := Utisaj - 1; 
      end; {if}
      if m - ZadnjiPrav > 1 then begin            { interpoliraj } 
        k := (Vrsta[m] - Vrsta[ZadnjiPrav]) / (m - ZadnjiPrav);  
        for i := ZadnjiPrav + 1 to m - 1 do 
          Vrsta[i] := Vrsta[ZadnjiPrav] + Round(k * (i - ZadnjiPrav)); 
      end; {if}
      ZadnjiPrav := m; 
    end else if Utisaj = 30 then begin            { dalja napaka e vedno traja } 
      Vrsta[m] := 0; ZadnjiPrav := m; 
    end else if m - ZadnjiPrav > 9 then begin     { zadnjih 10 vzorcev je napanih } 
      { postopno utiaj 30 vzorcev pred napanimi } 
      for i := ZadnjiPrav - 30 + 1 to ZadnjiPrav do 
        Vrsta[i] := Vrsta[i] * (ZadnjiPrav - i + 1) div 31; 
      for i := ZadnjiPrav + 1 to m do Vrsta[i] := 0; 
      { treba bo postopno dvigniti jakost 30-tim pravilnim vzorcem } 
      Utisaj := 30; ZadnjiPrav := m; 
    end; {if}
  until false; 
  { e je v vrsti e kaj dobrih vzorcev, jih poljimo naprej,
    napane vzorce na koncu posnetka pa ignorirajmo. }
  for i := NaZacetku + 1 to ZadnjiPrav do PosljiVzorec(Vrsta[i]);
end. {CD} 
