program Obrobljanje; { RTK 1989.3.2 }

{ Program prebere opis polja s standardnega vhoda.
  V prvi vrstici naj bosta irina in viina, loeni s presledkom.
  Nato sledi Visina vrstic, vsaka ima po Sirina znakov,
  ki so '.' za prazna in '#' za polna polja. 
  Program bo nakljuno izbral enega od likov na sliki,
  ga obrobil z znaki 'o' in izpisal novo polje. }

const MaxSirina = 50; MaxVisina = 20; 
var Polje: array[1..MaxSirina,1..MaxVisina] of integer; 
    Sirina, Visina: integer;

const Okolica: array[0..7] of record X, Y: integer end =  
  ( (X: 0; Y: 1), (X: -1; Y: 1), (X: -1; Y: 0), (X: -1; Y: -1), 
    (X: 0; Y: -1), (X: 1; Y: -1), (X: 1; Y: 0), (X: 1; Y: 1) ); 

{ Pove, e je dana celica prosta.  Zunaj polja si 
  mislimo same proste celice. }
function Prosta(X, Y: integer): boolean;
begin
  if (X < 1) or (Y < 1) or (X > Sirina) or (Y > Visina) then Prosta := true
  else Prosta := Polje[X, Y] = 0;
end; {Prosto}

procedure Meja(X0, Y0: integer); 
var i, LD, X, Y, Xn, Yn, X1, Y1: integer; Prvi: boolean;
begin
  LD := 3; { Delajmo se, da smo na trenutni poloaj prili s premikom v desno. } 
  X := X0; Y := Y0; Prvi := true;
  repeat
    Polje[X, Y] := -1; 
    { Poglejmo, v kateri smeri moramo nadaljevati. } 
    i := 0;
    while (i < 8) and Prosta(X + Okolica[LD].X, Y + Okolica[LD].Y) do 
      begin LD := (LD + 1) mod 8; i := i + 1 end;
    if i >= 8 then break; { Imamo "lik" velikosti 1 * 1. }
    { e smo korak (X, Y) -> (Xn, Yn) neko e naredili, smo prili zdaj
      e okoli in okoli lika in se moramo ustaviti. }
    Xn := X + Okolica[LD].X; Yn := Y + Okolica[LD].Y; 
    if Prvi then begin X1 := Xn; Y1 := Yn; Prvi := false end
    else if (X = X0) and (Y = Y0) and (Xn = X1) and (Yn = Y1) then break;
    X := Xn; Y := Yn;
    { Na naslednjem poloaju moramo zaeti preizkuati smeri pri LD - 3,
      torej z zasukom 135 stopinj v levo. }
    LD := (LD + 5) mod 8;   
  until false;
end; {Meja} 

{-----------------------------------------------------------------------------}
{ Testiranje.                                                                 }
{-----------------------------------------------------------------------------}

procedure PreberiPolje;
var x, y: integer; S: string;
begin
  ReadLn(Sirina, Visina);
  for x := 1 to MaxSirina do for y := 1 to MaxVisina do
    Polje[x, y] := 0;
  for y := 1 to Visina do begin
    ReadLn(S);
    for x := 1 to Sirina do 
      if S[x] = '#' then Polje[x, y] := 1
      else Polje[x, y] := 0;
  end; {for y}
end; {PreberiPolje}

procedure IzpisiPolje;
var x, y: integer;
begin
  for y := 1 to Visina do begin
    for x := 1 to Sirina do 
      if Polje[x, y] > 0 then Write('#')
      else if Polje[x, y] < 0 then Write('o')
      else Write('.');
    WriteLn;
  end; {for y}
end; {IzpisiPolje}

procedure IzberiZacetniPolozaj(var ZacX, ZacY: integer);
var 
  Sklad: array[1..MaxVisina * MaxSirina] of integer;
  n, i, x, y, xx, yy: integer;
begin
  { Nakljuno izberimo kakno celico, ki pripada kateremu od likov. }
  Randomize;
  repeat
    x := Random(Sirina) + 1; y := Random(Visina) + 1;
  until Polje[x, y] = 1;
  { Z iskanjem v globino preglejmo e preostanek tega lika, 
    da bomo odkrili najbolj levo med najbolj zgornjimi celicami. }
  n := 1; Sklad[n] := (y - 1) * Sirina + (x - 1); 
  ZacX := x; ZacY := y; Polje[x, y] := 2;
  while n > 0 do begin
    { Poglejmo naslednjo celico s sklada. }
    x := 1 + (Sklad[n] mod Sirina); y := 1 + (Sklad[n] div Sirina); 
    n := n - 1;
    { Mogoe je to nova najbolja kandidatka. }
    if (y < ZacY) or ((y = ZacY) and (x < ZacX)) then 
      begin ZacX := x; ZacY := y end;
    { Sosede trenutne celice, e niso prazne (Polje = 0) ali
      e obiskane (Polje = 2), dodajmo na sklad. }
    for i := 0 to 7 do begin
      xx := x + Okolica[i].X; yy := y + Okolica[i].Y;
      if (xx < 1) or (yy < 1) or (xx > Sirina) or (yy > Visina) then continue;
      if Polje[xx, yy] <> 1 then continue;
      Polje[xx, yy] := 2;
      n := n + 1; Sklad[n] := (yy - 1) * Sirina + (xx - 1);
    end; {for i}
  end; {while}
end; {IzberiZacetniPolozaj}

var ZacX, ZacY: integer;
begin {Obrobljanje}
  PreberiPolje;
  IzberiZacetniPolozaj(ZacX, ZacY);
  Meja(ZacX, ZacY);
  IzpisiPolje;
end. {Obrobljanje}
