program TuringovStroj(Input, Output); { RTK 1991.1.1 }

  type 
    SmerT = (eNazaj, eNaprej); 
    ZnakT = (e0, e1, eP); 
    
  procedure PremakniGlavo(Smer: SmerT); forward; 
  function PreberiZnak: ZnakT; forward; 
  procedure IzpisiZnak(Znak: ZnakT); forward; 
  
procedure NeznaniPodprogram;
begin
  while PreberiZnak <> eP do 
    if PreberiZnak = e0 then begin
      repeat PremakniGlavo(eNaprej) 
      until (PreberiZnak = e1) or (PreberiZnak = eP); 
      if PreberiZnak = eP then begin 
          PremakniGlavo(eNazaj); 
          IzpisiZnak(eP); 
      end else begin 
          PremakniGlavo(eNazaj); 
          IzpisiZnak(e1); 
          PremakniGlavo(eNaprej); 
      end; {if}
    end else begin 
      repeat PremakniGlavo(eNaprej) 
      until (PreberiZnak = e0) or (PreberiZnak = eP); 
      if PreberiZnak = eP then begin 
          PremakniGlavo(eNazaj); 
          IzpisiZnak(eP); 
      end else begin 
          PremakniGlavo(eNazaj); 
          IzpisiZnak(e0); 
          PremakniGlavo(eNaprej); 
      end; {if}
    end; {if}
end; {NeznaniPodprogram}

{-----------------------------------------------------------------------------}
{ Sledi implementacija zgoraj obljubljenih podprogramov, ki simulirajo        }
{ delovanje Turingovega stroja.                                               }
{-----------------------------------------------------------------------------}

var Trak: string; Polozaj: integer;

procedure PrikaziStanje;
begin
  WriteLn(Trak);
  WriteLn(' ':(Polozaj - 1), '^');
end; {PrikaziStanje}

procedure PremakniGlavo(Smer: SmerT);
begin
  if Smer = eNazaj then begin
    if Polozaj = 1 then 
      WriteLn('Nedovoljen premik (levo od zaetka traku).')
    else 
      Polozaj := Polozaj - 1;
  end else begin
    if Polozaj = Length(Trak) then Trak := Trak + '.';
    Polozaj := Polozaj + 1;
  end; {if}
  PrikaziStanje;
end; {PremakniGlavo}

function PreberiZnak: ZnakT; 
begin
  case Trak[Polozaj] of
    '1': PreberiZnak := e1;
    '0': PreberiZnak := e0;
    else PreberiZnak := eP;
  end; {case}
  PrikaziStanje;
end; {PreberiZnak}

procedure IzpisiZnak(Znak: ZnakT); 
var C: char;
begin
  case Znak of
    e0: C := '0';
    e1: C := '1';
    else C := ' ';
  end; {case}
  Trak := Copy(Trak, 1, Polozaj - 1) + C + 
          Copy(Trak, Polozaj + 1, Length(Trak) - Polozaj);
  PrikaziStanje;
end; {IzpisiZnak}

begin
  WriteLn('Simulator Turingovega stroja');
  if ParamCount > 0 then Trak := ParamStr(1)
  else begin 
    WriteLn('Vpii zaetno vsebino traku (znaki ''0'', ''1'' in '' ''): ');
    ReadLn(Trak);
  end; {if}
  Polozaj := 1;
  
  NeznaniPodprogram;
end. {TuringovStroj}
