program SimulatorCentrale;
uses Crt;
const StTelefonistov = 5;

{ Vmesnik, ki ga vidi tekmovalev podprogram TelefonskaCentrala. }
function Zvoni: boolean; forward;
procedure Zvezi(i: integer); forward;
function Pociva(i: integer): boolean; forward;

type
  ClenP = ^ClenT;
  ClenT = record
    i: integer; 
    Nasl: ClenP;
  end; {ClenT}
  SeznamT = record
    Glava, Rep: ClenP;
  end; {SeznamT}
  
var Zasedeni, Prosti: SeznamT;

{ To je podprogram, katerega delovanje naj bi opisal tekmovalec.
  Glavni del programa bo klical ta podprogram v neskonni zanki. }
procedure TelefonskaCentrala;
var P, Prej: ClenP;
begin

  { Poglejmo, e se je pojavil nov klic (in e je 
    kak telefonist prost, da bi ga lahko prevzel). }
  if Zvoni and (Prosti.Glava <> nil) then begin
    { Vzemimo prvega prostega... }
    P := Prosti.Glava; Prosti.Glava := P^.Nasl;
    if Prosti.Glava = nil then Prosti.Rep := nil;
    { ...in ga dodajmo na konec seznama zasedenih. }
    if Zasedeni.Rep = nil then Zasedeni.Glava := P
    else Zasedeni.Rep^.Nasl := P;
    Zasedeni.Rep := P; P^.Nasl := nil;
    { Ta telefonist naj prevzame trenutni klic. }
    Zvezi(P^.i);
  end; {if}

  { Poglejmo, e je kateri od telefonistov, ki so bili
    doslej zasedeni, medtem postal prost. }
  P := Zasedeni.Glava; Prej := nil;
  while P <> nil do begin
    if Pociva(P^.i) then begin
      { Zbrisimo P iz seznama zasedenih. }
      if Prej <> nil then Prej^.Nasl := P^.Nasl
      else Zasedeni.Glava := P^.Nasl;
      { Dodajmo P na konec seznama prostih. }
      if Prosti.Rep = nil then Prosti.Glava := P
      else Prosti.Rep^.Nasl := P;
      Prosti.Rep := P; P^.Nasl := nil;
    end else 
      Prej := P;
    { Gremo na naslednjega zasedenega.  Pazimo na to,
      da smo trenutnega mogoe zbrisali, zato ne smemo
      uporabiti P^.Nasl. }
    if Prej = nil then P := Zasedeni.Glava
    else P := Prej^.Nasl;
  end; {while}
  
end; {TelefonskaCentrala}

{-----------------------------------------------------------------------------}
{ Preostanek programa simulira (ob sodelovanju uporabnika) dogajanje          }
{ v telefonski centrali.                                                      }
{-----------------------------------------------------------------------------}

var 
  ZvoniB: boolean; { ali trenutno zvoni telefon (klic, ki ga je treba prevzeti) }
  Cas: integer;    { trenutni as, v milisekundah }
  { as, od katerega ta telefonist pociva.  e je trenutno zaseden,
    bo PocivaOd[i] = -1. }
  PocivaOd: array[1..StTelefonistov] of integer;

function Zvoni: boolean;
begin 
  Zvoni := ZvoniB; 
end; {Zvoni}

procedure Zvezi(i: integer);
begin
  PocivaOd[i] := -1;   { Telefonist i ne poiva ve... }
  ZvoniB := false;     { ...telefon pa tudi ne zvoni ve. }
end; {Zvezi}

function Pociva(i: integer): boolean;
begin
  Pociva := PocivaOd[i] >= 0;
end; {Pociva}

procedure PrikaziStanje;
var i: integer;
begin
  Write('[T = ', (Cas / 1000.0):5:1, ']  ');
  if ZvoniB then Write('ZVONI') else Write('     ');
  Write(' ');
  { Ob vsakem telefonistu zapiimo, ali dela oz. kako dolgo poiva. }
  for i := 1 to StTelefonistov do 
    if PocivaOd[i] >= 0 then Write(' ', ((Cas - PocivaOd[i]) / 1000.0):5:1)
    else Write('  dela');
  Write(#13);
end; {PrikaziStanje}

var i: integer; c: char; P: ClenP;
begin {SimulatorCentrale}

  WriteLn('Simulator telefonske centrale');
  WriteLn('Q, X = izhod iz programa.  K = klic (ali prekinitev klica).');
  WriteLn('1, ..., ', StTelefonistov, ' = prekinitev zveze posameznega telefonista.');
  WriteLn;

  ZvoniB := false; Cas := 0;
  for i := 1 to StTelefonistov do PocivaOd[i] := 0;
  Zasedeni.Glava := nil; Zasedeni.Rep := nil;
  Prosti.Glava := nil; Prosti.Rep := nil;
  for i := StTelefonistov downto 1 do begin
    New(P); P^.i := i; P^.Nasl := Prosti.Glava;
    if Prosti.Rep = nil then Prosti.Rep := P;
    Prosti.Glava := P;
  end; {for i}
  
  while true do begin
  
    while KeyPressed do begin
      c := UpCase(ReadKey); if c = #0 then c := ReadKey;
      if (c = 'Q') or (c = 'X') then exit;
      if c = 'K' then ZvoniB := not ZvoniB;
      i := Ord(c) - Ord('0');
      if (1 <= i) and (i <= StTelefonistov) then
        if PocivaOd[i] < 0 then PocivaOd[i] := Cas;
      if c = 'P' then begin
        Write('(pavza)', #13);
        repeat until KeyPressed;
      end; {if}
    end; {while}

    TelefonskaCentrala;
      
    PrikaziStanje;
    Delay(100); Cas := Cas + 100;
  end; {while}

end. {SimulatorCentrale}
