program KrmiljenjeRisalnika; { RTK 1993.2.2 }
{ Sintaksa: rtk93s2n2 [datoteka [n]]
  'datoteka' je ime datoteke z ukazi.  e je ni,
  uporabi 'rtk93s2n2.in'.  e je prisoten e drugi
  parameter in se zane na rko N, bo program
  poiljal ukaze naravnost risalniku. }
uses Graph;
const StPeres = 16; 
type
  OperacijaT = (opPeroGor, opPeroDol, opPero, opPremik, opKonec); 
  UkazT = record 
    case Kaj: OperacijaT of 
      opPero: (n: integer); 
      opPremik: (x, y: integer); 
  end; {UkazT} 

{ V tej vrsti hranimo ukaze, ki se jih ne da izvesti s trenutnim
  peresom.  Ko je vrsta polna, pero zamenjamo in izvedemo ukaze,
  ki se nanaajo nanj. }
const MaxVrsta = 50; 
var Vrsta: array[0..MaxVrsta - 1] of UkazT; 
    Glava, DolVrste: integer; 

procedure VrstaVzemi(var Ukaz: UkazT); 
begin 
  Ukaz := Vrsta[Glava]; Glava := Glava + 1; DolVrste := DolVrste - 1;
  if Glava = MaxVrsta then Glava := 0;
end; {VrstaVzemi}

procedure VrstaDodaj(Ukaz: UkazT);  
begin
  Vrsta[(Glava + DolVrste) mod MaxVrsta] := Ukaz; 
  DolVrste := DolVrste + 1;
end; {VrstaDodaj}

var 
  { Kolikokrat[i] = koliko je v vrsti takih ukazov, 
    ki jih je treba izvesti s peresom i }
  Kolikokrat: array[1..StPeres] of integer; 
  { Katero je trenutno pero risalnika in katero bi bilo
    trenutno, e bi vse raunalnikove ukaze poiljali
    naravnost risalniku? }
  PeroRisalnika, PeroRacunalnika: integer; 
 
{ Polje ukaz risalniku. }
procedure PosljiUkaz(Ukaz: UkazT); forward; 
{ Preklopi risalnik na pero NovoPero in mu polje vse 
  tiste ukaze iz vrste, ki se nanaajo na to pero. }
procedure PocistiPero(NovoPero: integer); forward; 

{ Obdela ukaz, ki je priel z raunalnika.  
  e ga lahko izvede takoj, brez menjave peresa na
  risalniku, to tudi stori, sicer pa ga doda v vrsto.
  e je vrsta e polna, klie PocistiPero za najvekrat
  uporabljeno pero v vrsti, tako da se vrsta im bolj izprazni. }
procedure ObdelajUkaz(Ukaz: UkazT); 
var Pero, NajPero: integer; 
begin
  if Ukaz.Kaj = opPero then { Zapomnimo si novo pero. } 
    PeroRacunalnika := Ukaz.n; 
  if PeroRacunalnika = PeroRisalnika then begin
    { Ukaz lahko poljemo naravnost risalniku.  e je to ukaz 
      za menjavo peresa na isto pero, ki je e v risalniku,
      bi bil uinek tega dokaza le dvig in premik peresa;
      in ker naj bi bil prvi raunalnikov ukaz po menjavi peresa
      itak premik, je za nas tule pomemben le dvig peresa.
      Zato raje poljimo ukaz za dvig peresa, saj se izvede
      hitreje kot ukaz za menjavo peresa. }
    if Ukaz.Kaj = opPero then Ukaz.Kaj := opPeroGor; 
    PosljiUkaz(Ukaz); 
  end else begin 
    { Ukaz bo treba zaasno shraniti v vrsti. }
    if DolVrste = MaxVrsta then begin
      WriteLn('Vrsta je polna.');
      { Vrsta je polna -- preklopimo na kakno drugo pero,
        da bomo lahko ukaze zanj odstranili iz vrste.
        Za katero pero imamo najve ukazov? } 
      NajPero := 1; 
      for Pero := 2 to StPeres do 
        if Kolikokrat[Pero] > Kolikokrat[NajPero] then NajPero := Pero; 
      { Preklopimo na to pero in takoj izvedimo ukaze zanj. } 
      WriteLn('Vrsta je polna -- preklapljamo na pero ', NajPero, '.');
      PocistiPero(NajPero); 
      { Zdaj se lahko posvetimo ukazu Ukaz -- kar pokliimo
        sami sebe; e je PeroRacunalnika = PeroRisalnika,
        ga bo treba takoj izvesti, drugae pa dodati v vrsto. }
      ObdelajUkaz(Ukaz);
    end else begin
      { V vrsti je e dovolj prostora, kar dodajmo ukaz tja. }
      VrstaDodaj(Ukaz); Kolikokrat[PeroRacunalnika] := Kolikokrat[PeroRacunalnika] + 1;
    end; {if}
  end; {if}
end; {ObdelajUkaz} 

{ Preklopi na dano pero in izvede vse ukaze zanj,
  ki se trenutno nahajajo v vrsti. }
procedure PocistiPero(NovoPero: integer); 
var Pero, StUkazov: integer; Ukaz: UkazT; 
begin
  WriteLn('Zaetek PocistiPero(', NovoPero, ').  Dolina vrste: ', DolVrste, '.');
  WriteLn('Pero raunalnika: ', PeroRacunalnika, ', risalnika: ', PeroRisalnika, '.');
  { Ukaze bomo na novo prebirali in posiljali podprogramu ObdelajUkaz. 
    Zato postavimo tevce na 0, saj jih bo ObdelajUkaz ponovno poveeval. }
  for Pero := 1 to StPeres do Kolikokrat[Pero] := 0; 
  { Preklopimo na to pero. } 
  Ukaz.Kaj := opPero; Ukaz.n := NovoPero; PosljiUkaz(Ukaz); 
  PeroRisalnika := NovoPero; 
  { Poljimo vse ukaze iz vrste e enkrat skozi podprogram 
    ObdelajUkaz.  Tisti, ki se nanaajo na novo pero, se bodo 
    pri tem zares izvedli, ostali pa bodo prili nazaj v vrsto. }
  StUkazov := DolVrste; Pero := 0; 
  while StUkazov > 0 do begin 
    VrstaVzemi(Ukaz); 
    ObdelajUkaz(Ukaz); 
    StUkazov := StUkazov - 1; 
  end; {while}
  WriteLn('Konec PocistiPero(', NovoPero, ').  Dolina vrste: ', DolVrste, '.');
  WriteLn('Pero raunalnika: ', PeroRacunalnika, ', risalnika: ', PeroRisalnika, '.');
end; {PocistiPero} 

procedure IzpisiUkaz(Ukaz: UkazT);
const Ime: array[OperacijaT] of string = ('PeroGor', 'PeroDol', 'Pero', 'Premik', 'Konec');
begin
  Write(Ime[Ukaz.Kaj]);
  if Ukaz.Kaj = opPero then Write(' ', Ukaz.n)
  else if Ukaz.Kaj = opPremik then Write(' ', Ukaz.x, ' ', Ukaz.y);
end; {IzpisiUkaz}

{ Statistika -- kolikokrat je menjavo peresa zahteval raunalnik,
  kolikokrat pa se je zares izvedla na risalniku. }
var StMenjavRac, StMenjavRis: integer;

{ Prebere naslednji ukaz iz datoteke T. }  
procedure BeriUkaz(var T: text; var Ukaz: UkazT); 
var S, Op: string; i, c, n: integer;

  function Nasl: string; { Vrne koek niza S do naslednjega presledka. }
  var j: integer;
  begin
    while i <= n do if S[i] = ' ' then i := i + 1 else break;
    j := i; while j <= n do if S[j] = ' ' then break else j := j + 1;
    Assert(j > i);
    Nasl := Copy(S, i, j - i); i := j;
  end; {Nasl}

begin {BeriUkaz}
  { Poiimo naslednjo neprazno vrstico. }
  S := '';
  while not Eof(T) do begin
    ReadLn(T, S); 
    i := 1; while i <= Length(S) do 
      if S[i] = ' ' then i := i + 1 else break;
    S := Copy(S, i, Length(S) + 1 - i);
    if S <> '' then break; 
  end; {while}
  if S = '' then begin Ukaz.Kaj := opKonec; exit; end;
  { Postavimo vse v velike rke. }
  n := Length(S);
  for i := 1 to n do S[i] := UpCase(S[i]);
  { Katera operacija je to? }
  i := 1; Op := Nasl;
  if Op = 'PEROGOR' then Ukaz.Kaj := opPeroGor
  else if Op = 'PERODOL' then Ukaz.Kaj := opPeroDol
  else if Op = 'PERO' then Ukaz.Kaj := opPero
  else if Op = 'PREMIK' then Ukaz.Kaj := opPremik
  else if Op = 'KONEC' then Ukaz.Kaj := opKonec
  else begin WriteLn('Neznan ukaz: ', Op); Halt; end;
  { Preberimo e koordinate ali tevilko peresa, e je treba. }
  if Ukaz.Kaj = opPero then begin 
    Val(Nasl, Ukaz.n, c); Assert(c = 0); 
    StMenjavRac := StMenjavRac + 1;
  end else if Ukaz.Kaj = opPremik then begin
    Val(Nasl, Ukaz.x, c); Assert(c = 0); 
    Val(Nasl, Ukaz.y, c); Assert(c = 0); 
  end; {if}
  Write('Racunalnik >> '); IzpisiUkaz(Ukaz); WriteLn;
end; {BeriUkaz}

{ (RisalnikX0, RisalnikY0) sta koordinati, kamor se
  risalnik premakne po zamenjavi peresa. }
const RisalnikX0 = 123; RisalnikY0 = 456;
{ Trenutno stanje risalnika (za podprogram PosljiUkaz). }
var JePeroGor: boolean; RisalnikX, RisalnikY: integer;

{ Ta podprogram naj bi poslal dani ukaz risalniku.
  V resnici ga izvede na zaslonu. }
procedure PosljiUkaz(Ukaz: UkazT); 
begin
  Write('Risalnik   << '); IzpisiUkaz(Ukaz); WriteLn;
  case Ukaz.Kaj of
    opPeroGor: JePeroGor := true;
    opPeroDol: JePeroGor := false;
    opPero: begin 
      SetColor(Ukaz.n); 
      StMenjavRis := StMenjavRis + 1;
      { Recimo, da je pero po menjavi dvignjeno in na poloaju (X0, Y0). }
      RisalnikX := RisalnikX0; RisalnikY := RisalnikY0; 
      JePeroGor := true;
    end; {opPero}
    opPremik: begin
      if not JePeroGor then Line(RisalnikX, RisalnikY, Ukaz.x, Ukaz.y);
      RisalnikX := Ukaz.x; RisalnikY := Ukaz.y; 
    end; {opPremik}
  end; {case}
  {ReadLn;}
end; {PosljiUkaz}

var Ukaz: UkazT; Pero: integer; 
    GDrv, GMode: word; T: text;
    NaravnostVRisalnik: boolean;
begin {KrmiljenjeRisalnika} 

  GDrv := Detect; InitGraph(GDrv, GMode, 'c:\bp\bgi'); 
  if GraphResult <> grOk then Halt(1); 
  RisalnikX := RisalnikX0; RisalnikY := RisalnikY0; JePeroGor := true; 
  SetColor(3); { izmislimo si zaetno pero }
  
  if ParamCount >= 1 then Assign(T, ParamStr(1))
  else Assign(T, 'rtk93s2n2.in');
  Reset(T);
  NaravnostVRisalnik := false;
  if ParamCount >= 2 then 
    if UpCase(ParamStr(2)[1]) = 'N' then 
      NaravnostVRisalnik := true;

  for Pero := 1 to StPeres do Kolikokrat[Pero] := 0; 
  PeroRacunalnika := 0; PeroRisalnika := 0; 
  StMenjavRac := 0; StMenjavRis := 0;
  while not Eof(T) do begin { Neskonna zanka. } 
    BeriUkaz(T, Ukaz); 
    while Ukaz.Kaj <> opKonec do begin 
      if NaravnostVRisalnik then PosljiUkaz(Ukaz)
      else ObdelajUkaz(Ukaz); 
      BeriUkaz(T, Ukaz); 
    end; {while}
    { Risbe je konec; poljimo risalniku e ukaze, ki akajo v vrsti. } 
    WriteLn('Risbe je konec; izpraznimo vrsto.');
    if not NaravnostVRisalnik then for Pero := 1 to StPeres do 
      if Kolikokrat[Pero] > 0 then PocistiPero(Pero); 
    PosljiUkaz(Ukaz); { Poljimo mu e ukaz za konec risbe. } 
  end; {while}
  
  WriteLn('tevilo menjav peresa: na raunalniku ', StMenjavRac, ', na risalniku ', StMenjavRis, '.');
  WriteLn('Pritisni Enter za izhod iz programa.');
  ReadLn;
  CloseGraph;
  Close(T);
  
end. {KrmiljenjeRisalnika} 

