program KdoJeKdo; { RTK 1995.1.2 }
type 
  Oseba = (tone, marjan, miha, janez, barbara, alenka, 
           franc, peter, dare, andrej, pavel, joze); 
  SefRec = record Sef, Delavec: Oseba end; 
const 
  NumRel = 14; 
  Sefi: array[1..NumRel] of SefRec = (
    (Sef: marjan; Delavec: tone), 
    (Sef: marjan; Delavec: miha), 
    (Sef: marjan; Delavec: janez), 
    (Sef: marjan; Delavec: dare), 
    (Sef: franc; Delavec: alenka), 
    (Sef: franc; Delavec: barbara), 
    (Sef: franc; Delavec: peter), 
    (Sef: franc; Delavec: dare), 
    (Sef: franc; Delavec: andrej), 
    (Sef: tone; Delavec: peter), 
    (Sef: pavel; Delavec: franc), 
    (Sef: pavel; Delavec: marjan), 
    (Sef: joze; Delavec: marjan), 
    (Sef: joze; Delavec: janez)); 
  Ime: array[Oseba] of string = ('Tone', 'Marjan', 'Miha', 'Janez',
    'Barbara', 'Alenka', 'Franc', 'Peter', 'Dare', 'Andrej', 'Pavel', 'Joe');
type VsiSefiT = array[Oseba] of boolean; 

{ Funkcija vrne true, e je delavec x neposredni ef delavcu y. }
function Sef(x, y: Oseba): boolean; 
var i: integer; 
begin
  Sef := false; 
  for i := 1 to NumRel do 
    if (Sefi[i].Sef = x) and (Sefi[i].Delavec = y) then 
      begin Sef := true; exit; end
end; {Sef} 

{ Podprogram poie vse nadrejene delavce delavcu x in jih v polju V oznai. } 
procedure Nadrejeni(x: Oseba; var V: VsiSefiT); 
var Konec: boolean; 
    i, j: Oseba; 
begin
  { Inicializacija polja V. } 
  for i := Low(Oseba) to High(Oseba) do V[i] := false; 
  V[x] := true; 
  { Poii vse nadrejene efe. } 
  repeat 
    Konec := true; 
    for i := Low(Oseba) to High(Oseba) do 
      if V[i] then 
        for j := Low(Oseba) to High(Oseba) do 
          if Sef(Oseba(j), Oseba(i)) and not V[j] then 
            begin Konec := false; V[j] := true; end;
  until Konec; 
  { Oseba x ni v mnoici efov. } 
  V[x] := false; 
end; {Nadrejeni} 

var i: integer; x, y: Oseba; V: VsiSefiT;
begin {KdoJeKdo}
  WriteLn('Pari delavec-ef:');
  for i := 1 to NumRel do WriteLn('    (', Ime[Sefi[i].Delavec], ', ', Ime[Sefi[i].Sef], ')');
  for x := Low(Oseba) to High(Oseba) do begin
    Write('Nadrejeni(', Ime[x], '): ');
    Nadrejeni(x, V);  
    for y := Low(Oseba) to High(Oseba) do 
      if V[y] then Write(' ', Ime[y]);
    WriteLn;
  end; {for x}
end. {KdoJeKdo}
