# -*- coding: Windows-1250 -*-
StSegmentov = 7 
OpisiStevk = [ [1, 2, 3, 5, 6, 7], [3, 6], [1, 3, 4, 5, 7], [1, 3, 4, 6, 7],  
               [2, 3, 4, 6], [1, 2, 4, 6, 7], [1, 2, 4, 5, 6, 7],  
               [1, 3, 6],  [1, 2, 3, 4, 5, 6, 7], [1, 2, 3, 4, 6, 7]    ] 
StStevk = len(OpisiStevk) 

def Podmnozica(pod, mnozica): 
    for i in pod:  
        if not i in mnozica: return False 
    return True 

def RazlikaMnozic(odstej, odMnozice): 
    return [i for i in odMnozice if not i in odstej] 

class Spremenljivka: 
    # Atributi tega razreda: zaloga --- seznam monih vrednosti; 
    # zaloge --- sklad prejnjih seznamov "zaloga" (za backtracking); 
    # omejitve --- seznam omejitev, v katerih nastopa ta spremenljivka; 
    # min, max --- najmanja in najveja vrednost iz seznama "zaloga". 
    vse = []     # statien seznam vseh spremenljivk v sistemu 
    def __init__(self, zaloga = []): 
        self.omejitve = []; self.NovaZaloga(zaloga[:], []) 
        Spremenljivka.vse.append(self); self.zaloge = [] 
    def NovaZaloga(self, novaZaloga, spremenjene): 
        self.zaloga = novaZaloga 
        if self.zaloga == []: self.min = 9999; self.max = -9999 
        else: self.min = min(self.zaloga); self.max = max(self.zaloga) 
        if not self in spremenjene: spremenjene.append(self) 

def PushZaloge(): 
    for s in Spremenljivka.vse: s.zaloge.append(s.zaloga[:]) 
def PopZaloge(): 
    for s in Spremenljivka.vse: s.NovaZaloga(s.zaloge.pop(), []) 

class Omejitev: pass 

class Manjsa(Omejitev): 
    # Atributa: s --- neka spremenljivka; meja --- neko celo tevilo. 
    # To predstavlja omejitev "s < meja". 
    def __init__(self, spremenljivka, meja): 
        self.s = spremenljivka; self.meja = meja 
        self.s.omejitve.append(self) 
    def uskladi(self, spremenjene): 
        if self.s.max >= self.meja: 
            self.s.NovaZaloga([i for i in self.s.zaloga if i < self.meja], spremenjene) 

class Vsota(Omejitev): 
    # Atributa: v --- neka spremenljivka; s --- seznam spremenljivk. 
    # Predstavlja omejitev "v == s[0] + s[1] + ... + s[len(s) - 1]".
    def __init__(self, vsota, sestevanci): 
        self.v = vsota; self.sestevanci = sestevanci; 
        self.v.omejitve.append(self) 
        for s in self.sestevanci: s.omejitve.append(self) 
    def uskladi(self, spremenjene): 
        while True: 
            minVsota = 0; maxVsota = 0; spremembe = False 
            # Setevanci lahko vplivajo na vsoto. 
            for s in self.sestevanci: minVsota += s.min; maxVsota += s.max; 
            if len(self.v.zaloga) > 0 and (minVsota > maxVsota or (self.v.min < minVsota or self.v.max > maxVsota)): 
                self.v.NovaZaloga([i for i in self.v.zaloga 
                                     if minVsota <= i <= maxVsota], spremenjene) 
                spremembe = True 
            # Vsota lahko vpliva na setevance. 
            for s in self.sestevanci: 
                maxS = self.v.max - (minVsota - s.min) 
                minS = self.v.min - (maxVsota - s.max) 
                if len(s.zaloga) > 0 and (len(self.v.zaloga) == 0 or (s.min < minS or maxS < s.max)): 
                    s.NovaZaloga([i for i in s.zaloga if minS <= i <= maxS], spremenjene) 
                    spremembe = True 
            if not spremembe: return

class Ostanek(Omejitev): 
    # Atributi: s --- neka spremenljivka; d, o --- celi tevili. 
    # Predstavlja omejitev "s % d == o." 
    def __init__(self, spremenljivka, delitelj, ostanek): 
        self.s = spremenljivka; self.d = delitelj; self.o = ostanek 
        self.s.omejitve.append(self) 
    def uskladi(self, spremenjene): 
        novaZaloga = [i for i in self.s.zaloga if i % self.d == self.o] 
        if len(novaZaloga) != len(self.s.zaloga): 
            self.s.NovaZaloga(novaZaloga, spremenjene) 

class Razlika(Omejitev): 
    # Atributi: r, c --- dve spremenljivki; vidni --- seznam segmentov. 
    # Predstavlja omejitev "r == mo mnozice(OpisiStevk[c] - vidni)". 
    def __init__(self, razlika, stevka, vidniSegmenti): 
        self.r = razlika; self.c = stevka; self.vidni = vidniSegmenti 
        self.r.omejitve.append(self); self.c.omejitve.append(self) 
    def uskladi(self, spremenjene): 
        while True: 
            spremembe = False 
            # tevka lahko vpliva na razlike. 
            mozneRazlike = [len(RazlikaMnozic(self.vidni, OpisiStevk[i])) for i in self.c.zaloga] 
            novaZaloga = [i for i in self.r.zaloga if i in mozneRazlike] 
            if len(novaZaloga) != len(self.r.zaloga): 
                self.r.NovaZaloga(novaZaloga, spremenjene); spremembe = True 
            # Razlike lahko vplivajo na tevko. 
            mozneStevke = [i for i in self.c.zaloga 
                             if len(RazlikaMnozic(self.vidni, OpisiStevk[i])) in self.r.zaloga] 
            if len(mozneStevke) != len(self.c.zaloga): 
                self.c.NovaZaloga(mozneStevke, spremenjene); spremembe = True 
            if not spremembe: return

def UskladiOmejitve(omejitve): 
    while len(omejitve) > 0: 
        spremenjene = []     # Spremenljivke, ki se jim je zaloga vrednosti spremenila. 
        for o in omejitve: o.uskladi(spremenjene) 
        # V nadaljevanju bo treba uskladiti vse omejitve,  
        # ki vsebujejo kakno spremenljivko iz seznama "spremenjene".
        omejitve = [] 
        for s in spremenjene:  
            for o in s.omejitve: 
                if not o in omejitve: omejitve.append(o) 

def PrirediVrednost(i): 
    global n, spStevke, spRazlike, spVsota, spVsotaRazlik, omejitve 
    if i == n: 
        print "Rezultat: %s, vsota = %s, vsota razlik = %s" % ( 
            [c.zaloga[0] for c in spStevke], spVsota.zaloga, spVsotaRazlik.zaloga) 
        assert len(spVsotaRazlik.zaloga) == 1 
        # Nali smo novo najboljo reitev.  Ta zdaj postane omejitev 
        # pri nadaljnjem iskanju.  Zadnja omejitev v seznamu "omejitve" 
        # je ravno omejitev "vsota razlik < doslej najbolja znana vsota razlik".
        omejitve[len(omejitve) - 1].meja = spVsotaRazlik.zaloga[0] 
        return
    zaloga = spStevke[i].zaloga[:]
    for j in zaloga: 
        PushZaloge() 
        spStevke[i].NovaZaloga([j], []) # Izberimo naslednjo mono vrednost j-te tevke. 
        UskladiOmejitve(spStevke[i].omejitve)  
        PrirediVrednost(i + 1) 
        PopZaloge()     # backtrack 
        # e smo medtem nali kakno novo boljo reitev, lahko zaloge vrednosti
        # e malo poklestimo. 
        UskladiOmejitve([omejitve[-1]])     

def BruteForce(i, stevke, vsota, razlika, vidniSegmenti): 
    global bfBest, bfBestR 
    if i == n: 
        if vsota % 10 == 0 and razlika < bfBestR: 
            print "BruteForce: %s (vsota = %d, razlika = %d)" % (stevke, vsota, razlika) 
            bfBest = stevke; bfBestR = razlika 
    else:
        for j in spStevke[i].zaloga: 
            novaRazlika = razlika + len(RazlikaMnozic(vidniSegmenti[i], OpisiStevk[j])) 
            if novaRazlika < bfBestR: 
                BruteForce(i + 1, stevke + [j], vsota + j, novaRazlika, vidniSegmenti) 

def PoisciVrednosti(vidniSegmenti): 
    global n, spStevke, spRazlike, spVsota, spVsotaRazlik, omejitve 
    import time 
    print 
    print "Vidni segmenti: %s" % vidniSegmenti
    n = len(vidniSegmenti) 
    # Pripravimo primerke razreda Spremenljivka. 
    spStevke = []         # spStevke[i] predstavlja tevko na i-tem mestu na zaslonu,
    spRazlike = []        # spRazlike[i] predstavlja stevilo segmentov, po katerih se to mesto
                          # zaslona razlikuje od tevke spStevke[i].
    for i in range(n):   
        # Zaetna zaloga vrednosti vsake tevke je pa mnoica 
        # tistih tevk, ki vsebujejo vse segmente, ki so vidni na tem mestu. 
        spStevke.append(Spremenljivka([j for j in range(StStevk) 
                                         if Podmnozica(vidniSegmenti[i], OpisiStevk[j])] )) 
        spRazlike.append(Spremenljivka(range(0, StSegmentov + 1))) 
    spVsota = Spremenljivka(range(0, n * (StStevk - 1) + 1))       # vsota tevk 
    spVsotaRazlik = Spremenljivka(range(0, n * StSegmentov + 1))   # vsota razlik 
    
    # Za primerjavo poenimo e branch-and-bound. 
    global bfBestR; bfBestR = StSegmentov * n + 1; t = time.clock() 
    BruteForce(0, [], 0, 0, vidniSegmenti) 
    print "Brute-force je tekel %.3f s." % (time.clock() - t) 
    t = time.clock()    

    # Definirajmo omejitve.
    omejitve = [] 
    omejitve.append(Vsota(spVsota, spStevke))     # spVsota je vsota tevk 
    omejitve.append(Ostanek(spVsota, 10, 0))      # spVsota % 10 == 0 
    for i in range(n): 
        omejitve.append(Razlika(spRazlike[i], spStevke[i], vidniSegmenti[i])) # razlike 
    omejitve.append(Vsota(spVsotaRazlik, spRazlike))     # vsota razlik 
    # Naslednja omejitev je zdajle trivialna, kasneje pa bomo njeno mejo zmanjevali,  
    # ko bomo odkrili kakno reitev.  Tako bo ta omejitev vedno zahtevala, 
    # da mora biti naslednja reitev bolja od doslej najbolje znane. 
    omejitve.append(Manjsa(spVsotaRazlik, StSegmentov * n)) 
    # Mogoe lahko e na zaetku kaj oklestimo zaloge vrednosti.
    UskladiOmejitve(omejitve) 
    # Poenimo zdaj postopek izbiranja vrednosti spremenljivk spStevke[0..n-1].
    PrirediVrednost(0)     
    print "CLP je tekel %.3f s." % (time.clock() - t) 
  
  
# Primer iz besedila naloge. 
PoisciVrednosti([[1, 3, 4, 6, 7], [1, 3]]) 
# e en veji primer.
PoisciVrednosti([[1, 3, 4, 6, 7], [1, 3], [2, 4], [1, 7], [1, 2], [4], [6, 7], [1, 7], [1, 2, 3, 4]]) 