program KdoJeKdo2; { RTK 1995.3.3 }
type 
  Oseba = (tone, marjan, miha, janez, barbara, alenka, 
           franc, peter, dare, andrej, pavel, joze); 
  OsebaSet = set of Oseba;
  SefRec = record Sef, Delavec: Oseba end; 
const 
  NumRel = 14; 
  Sefi: array[1..NumRel] of SefRec = (
    (Sef: marjan; Delavec: tone), 
    (Sef: marjan; Delavec: miha), 
    (Sef: marjan; Delavec: janez), 
    (Sef: marjan; Delavec: dare), 
    (Sef: franc; Delavec: alenka), 
    (Sef: franc; Delavec: barbara), 
    (Sef: franc; Delavec: peter), 
    (Sef: franc; Delavec: dare), 
    (Sef: franc; Delavec: andrej), 
    (Sef: tone; Delavec: peter), 
    (Sef: pavel; Delavec: franc), 
    (Sef: pavel; Delavec: marjan), 
    (Sef: joze; Delavec: marjan), 
    (Sef: joze; Delavec: janez)); 
  Ime: array[Oseba] of string = ('Tone', 'Marjan', 'Miha', 'Janez',
    'Barbara', 'Alenka', 'Franc', 'Peter', 'Dare', 'Andrej', 'Pavel', 'Joe');

{ Funkcija vrne true, e je delavec x neposredni ef delavcu y. }
function Sef(x, y: Oseba): boolean; 
var i: integer; 
begin
  Sef := false; 
  for i := 1 to NumRel do 
    if (Sefi[i].Sef = x) and (Sefi[i].Delavec = y) then 
      begin Sef := true; exit; end
end; {Sef} 

{ Funkcija vrne vrednost true, e je x posredni ali neposredni ef osebe y. 
  Pri tem si pomaga s funkcijo Sef(x, y), ki pove, e je x neposredni ef osebe y. 
  Pri reevanju naloge predpostavljamo, da je ta funkcija dana. }
function JeSef(x, y: Oseba): boolean; 
var i: Oseba; 
begin
  if Sef(x, y) then 
    JeSef  := true
  else begin
    JeSef := false; 
    for i := Low(Oseba) to High(Oseba) do 
      if Sef(x, Oseba(i)) then 
        if JeSef(Oseba(i), y) then 
          begin JeSef := true; exit; end;
  end; {if}
end; {JeSef} 

{ Funkcija vrne vrednost true, e je delavec x ef vseh delavcev iz 
  mnoice S. V nasprotnem primeru funkcija vrne vrednost false. }
function SefVseh(x: Oseba; S: OsebaSet): boolean; 
var i: Oseba; 
begin
  SefVseh := true; 
  for i := Low(Oseba) to High(Oseba) do 
    if Oseba(i) in S then 
      if not JeSef(x, Oseba(i)) then 
        begin SefVseh := false; exit; end;
end; {SefVseh} 

{ Podprogram poie vse skupne efe delavcev iz mnoice S. } 
procedure VsiSkupniSefi(var S: OsebaSet); 
var vss: OsebaSet; i: Oseba; 
begin
  vss := []; 
  for i := Low(Oseba) to High(Oseba) do 
    if not (i in S) then 
      if SefVseh(Oseba(i), S) then 
        vss := vss + [Oseba(i)]; 
  S := vss; 
end; {VsiSkupniSefi} 

{ Podprogram izloi iz mnozice efov vse, ki niso najbliji 
  glede na relacijo JeSef. }
procedure NajblizjiSefi(var S: OsebaSet); 
var i, j: Oseba; 
begin
  for i := Low(Oseba) to High(Oseba) do 
    for j := Low(Oseba) to High(Oseba) do 
      if (i in S) and (j in S) and (i <> j) then 
        if JeSef(Oseba(j), Oseba(i)) then 
          S := S - [Oseba(j)]; 
end; {NajblizjiSefi} 

procedure IzpisiMnozico(S: OsebaSet);
var x: Oseba;
begin
  for x := Low(Oseba) to High(Oseba) do
    if x in S then Write(' ', Ime[x]);
end; {IzpisiMnozico}

var S: OsebaSet; i: integer;
begin {KdoJeKdo2} 
  WriteLn('Pari delavec-ef:');
  for i := 1 to NumRel do WriteLn('    (', Ime[Sefi[i].Delavec], ', ', Ime[Sefi[i].Sef], ')');
  WriteLn;
  
  S := [peter, dare]; 
  Write('S ='); IzpisiMnozico(S); WriteLn;
  VsiSkupniSefi(S); 
  Write('VsiSkupniSefi(S) ='); IzpisiMnozico(S); WriteLn;
  NajblizjiSefi(S); 
  Write('NajblizjiSefi(VsiSkupniSefi(S)) ='); IzpisiMnozico(S); WriteLn;
end. {KdoJeKdo2} 
