program Koncnice; { RTK 1997.1.3 }
const MaxN = 10000; MaxDolz = 15;  
type Niz = string[MaxDolz];
type Tabela = array[1..MaxN] of Niz; 

{ Naivna reitev, ki lahko porabi O(n^2) asa. }
procedure Koncnica1(s: Tabela; n: integer; 
                    var Koncnica: Niz; var NajZmnozek: integer);
var i, j, k, Zmnozek: integer; 
begin
  NajZmnozek := 0; Koncnica := s[1]; 
  for i := 1 to n do begin 
    j := i + ((NajZmnozek + 1) + (MaxDolz - 1) - 1) div (MaxDolz - 1); 
    if j > n then break; { odslej bi vedno imeli j > n } 
    while j <= n do begin 
      k := 0; 
      while (k < Length(s[i])) and (k < Length(s[j])) do 
        if s[i, Length(s[i]) - k] = s[j, Length(s[j]) - k] then k := k + 1 
        else break; 
      if k = 0 then { Besede od s[j] naprej nimajo s s[i] skupne nikakrne } 
        break;      { konnice ve.  Takoj se lahko lotimo naslednjega i. } 
      { Besedam s[i..j] je skupna konnica doline k. } 
      Zmnozek := k * (j - i); 
      if Zmnozek > NajZmnozek then begin 
        { To je najbolja doslej znana konnica -- zapomnimo si jo. } 
        Koncnica := Copy(s[i], Length(s[i]) - k + 1, k); 
        NajZmnozek := Zmnozek; 
      end; {if}
      j := j + 1; 
    end; {while}
  end; {for}
end; {Koncnica1}

{ Bolja reitev, ki porabi le O(n) asa. }
procedure Koncnica2(s: Tabela; n: integer; 
                    var Koncnica: Niz; var NajZmnozek: integer);
var g: array[1..MaxDolz] of integer; 
    i, j, b, bi, bj, c, Dolz, PrejDolz: integer; 
begin
  b := 0; bi := 1; bj := 0; Dolz := Length(s[1]); 
  for j := 1 to Dolz do g[j] := 1; 
  for i := 2 to n do begin 
    { V tabeli g so trenutno vrednosti, ki povedo, da se
      zadnjih g[j] besed (pred trenutno) ujema v zadnjih j znakih.
      Popravimo zdaj to tabelo tako, da se bo nanaala na
      zadnjih nekaj besed s trenutno vred.  Pri tem lahko e
      opazujemo, e bomo opazili kakno novo najboljo konnico. }
    PrejDolz := Dolz; Dolz := Length(s[i]); j := 0; 
    while (j < PrejDolz) and (j < Dolz) do 
      if s[i, Dolz - j] = s[i - 1, PrejDolz - j] then begin 
        j := j + 1; g[j] := g[j] + 1; 
        c := j * (g[j] - 1);  
        if c > b then { nova najbolja konnica } 
          begin b := c; bi := i; bj := j; end; 
      end
      else break; { konec ujemanja } 
    while j < Dolz do 
      begin j := j + 1; g[j] := 1; end; 
  end; {for}
  Koncnica := Copy(s[bi], Length(s[bi]) - bj + 1, bj); 
  NajZmnozek := b;
end; {Koncnica2} 

var T: text; Alg, i, n: integer; s: Tabela;
    Koncnica: Niz; NajZmnozek: integer;
begin {Koncnice}
  if ParamCount >= 2 then Assign(T, ParamStr(2))
  else Assign(T, 'rtk97s1n3.in');
  Reset(T);
  if ParamCount >= 1 then Val(ParamStr(1), Alg, n)
  else Alg := 2;
  WriteLn('Algoritem ', Alg);
  
  while not Eof(T) do begin
    ReadLn(T, n); if n <= 0 then break;
    for i := 1 to n do ReadLn(T, s[i]);
    if Alg = 1 then Koncnica1(s, n, Koncnica, NajZmnozek)
    else Koncnica2(s, n, Koncnica, NajZmnozek);
    WriteLn(Koncnica, ' ', NajZmnozek);
  end; {while}
  Close(T);
end. {Koncnice}
