program Vsote; { RTK 1998.3.3 }
const MaxN = 100;
type Tabela = array[1..MaxN] of integer; 

{ Naivna reitev -- O(n^2). }
procedure IzpisiPare1(a: Tabela; N: integer); 
var i, j: integer; 
begin
  for i := 1 to N - 1 do for j := i + 1 to N do
    if a[i] + a[j] = 100 then WriteLn(a[i], ' ', a[j]); 
end; {IzpisiPare1} 

{ Uinkoviteja reitev -- O(n). }
procedure IzpisiPare2(a: Tabela; N: integer); 
var Levi, Desni: integer; Vsota: real; 
begin
  Levi := 1; Desni := N; 
  while Levi < Desni do begin 
    Vsota := a[Levi] + a[Desni]; 
    if Vsota = 100 then WriteLn(a[Levi], ' ', a[Desni]); 
    if Vsota <= 100 then Levi := Levi + 1; 
    if Vsota >= 100 then Desni := Desni - 1 
  end; {while}
end; {IzpisiPare2} 

var a: Tabela; i, N: integer; T: text;
begin {Vsote}
  
  { Preberimo tabelo tevil. }
  if ParamCount >= 1 then Assign(T, ParamStr(1))
  else Assign(T, 'rtk98s3n3.in');
  Reset(T); Read(T, N);
  for i := 1 to N do Read(T, a[i]);
  Close(T);
  for i := 2 to N do Assert(a[i - 1] < a[i]);
  
  { Reimo nalogo na oba naina. }
  WriteLn('Reitev 1:');
  IzpisiPare1(a, N);
  WriteLn('Reitev 2:');
  IzpisiPare2(a, N);
end. {Vsote}
