program RazvrscanjeTekmovalcev; { RTK 1999.3.3 }

const MaxN = 100; { najveje mono tevilo tekmovalcev }
      MaxM = MaxN * (MaxN - 1); { in tekem }
type TabelaN = array[1..MaxN] of integer;
     TabelaM = array[1..MaxM] of integer;
     TabelaB = array[1..MaxN] of boolean;
var 
  N: integer; { tevilo tekmovalcev }
  M: integer; { tevilo tekem }
  i, u, v, s, t, StSkupin, ZadnjiVSkupini, Glava, Rep: integer;
  { Tabele z M elementi. }
  Kdo, OdKoga, { to se uporablja le pri branju grafa iz datoteke }
  { Predhodniki toke u so Pred^[PrviPred^[u] + i - 1] za i = 1..InDeg^[u].
    Podobno je z nasledniki. }
  Pred, Nasl: ^TabelaM; 
  { Tabele z N elementi. }
  PrviPred, PrviNasl,    { glej zgoraj }
  InDeg, OutDeg,         { tevilo predhodnikov in naslednikov }
  Skupina,               { v kateri skupini je toka }
  SkupNasl,              { katera je naslednja toka v isti skupini }
  Seznam: ^TabelaN;      { pri iskanju v globino }
  Obiskan: ^TabelaB;     { pri iskanju v globino }
  { Tabele s StSkupin elementi. }
  Vrsta,                 { za topoloko urejanje }
  InDegS,                { vsota vhodnih stopenj vseh tok v skupini }
  SkupPrvi: ^TabelaN;    { prva toka posamezne skupine }
  { Elementi vsake skupine so povezani v seznam; prvi je
    SkupPrvi^[s], nato pa sledimo kazalcem od u do SkupNasl^[u]. }
  
  { Iskanje v globino.  Tabela Obiskan pove, katere toke
    je e zael raziskovati.  Ko obie vse, kamor se je dalo
    priti iz neke toke, jo doda na konec seznama Seznam.
    Ta seznam pride prav pri drugi fazi iskanja skupin tekmovalcev
    (= iskanja krepko povezanih komponent v grafu). }
  procedure Dfs(u: integer);
  var j, v: integer;
  begin
    Obiskan^[u] := true;
    for j := 1 to OutDeg^[u] do begin
      v := Nasl^[PrviNasl^[u] + j - 1];
      if not Obiskan^[v] then Dfs(v);
    end; {for}
    Inc(i); Seznam^[i] := u;
  end; {Dfs}

  { Vse, od koder je dosegljiva toka u, uvrsti v trenutno skupino
    (v skupino StSkupin).  Te toke dodaja tudi na seznam elementov
    skupine, ki ga tvorijo kazalci SkupNasl.  Neobiskane toke
    prepoznamo po tem, da imajo Skupina^[u] = 0. }
  procedure OznaciSkupino(u: integer);
  var j, v: integer;
  begin
    Skupina^[u] := StSkupin;
    if ZadnjiVSkupini > 0 then SkupNasl^[ZadnjiVSkupini] := u;
    ZadnjiVSkupini := u; SkupNasl^[u] := 0;
    for j := 1 to InDeg^[u] do begin
      v := Pred^[PrviPred^[u] + j - 1];
      if Skupina^[v] = 0 then OznaciSkupino(v);
    end; {for}
  end; {OznaciSkupino}
  
begin {RazvrscanjeTekmovalcev}
  while not Eof do begin
  
    { Preberimo izide tekem.  V prvi vrstici naj bosta N in M,
      v ostalih pa pari (u, v), ki povedo, da je bil 
      u bolji od v-ja. }
    ReadLn(N, M); 
    if N = 0 then break;
    New(Kdo); New(OdKoga); New(InDeg); New(OutDeg);
    for u := 1 to N do 
      begin InDeg^[u] := 0; OutDeg^[u] := 0; end;
    for i := 1 to M do begin
      ReadLn(u, v); Kdo^[i] := u; OdKoga^[i] := v; 
      Inc(InDeg^[v]); Inc(OutDeg^[u]); 
    end; {for}
    
    { Pripravimo sezname predhodnikov in naslednikov. }
    New(Pred); New(PrviPred); New(Nasl); New(PrviNasl);
    PrviPred^[1] := 1; PrviNasl^[1] := 1;
    for u := 1 to N - 1 do begin
      PrviPred^[u + 1] := PrviPred^[u] + InDeg^[u];
      PrviNasl^[u + 1] := PrviNasl^[u] + OutDeg^[u];
      InDeg^[u] := 0; OutDeg^[u] := 0;
    end; {for}
    InDeg^[N] := 0; OutDeg^[N] := 0;
    for i := 1 to M do begin
      u := Kdo^[i]; v := OdKoga^[i];
      Pred^[PrviPred^[v] + InDeg^[v]] := u; Inc(InDeg^[v]);
      Nasl^[PrviNasl^[u] + OutDeg^[u]] := v; Inc(OutDeg^[u]);
    end; {for}
    Dispose(Kdo); Dispose(OdKoga);
    
    { Klasini algoritem za odkrivanje krepko povezanih
      komponent v asu O(N + M) je sestavljen iz dveh faz: }
    { - Iskanje v globino. }
    i := 0; New(Seznam); New(Obiskan);
    for u := 1 to N do Obiskan^[u] := false;
    for u := 1 to N do if not Obiskan^[u] then Dfs(u);
    Assert(i = N); Dispose(Obiskan);
    { - Iskanje v globino v nasprotni smeri povezav. }
    StSkupin := 0; New(Skupina); New(SkupNasl); New(SkupPrvi);
    for u := 1 to N do Skupina^[u] := 0;
    for i := N downto 1 do begin
      u := Seznam^[i]; 
      if Skupina^[u] <> 0 then continue;
      Inc(StSkupin); SkupPrvi^[StSkupin] := u;
      ZadnjiVSkupini := 0; OznaciSkupino(u);
    end; {for}
    Dispose(Seznam);
    
    { Skupine doloajo nov graf.  Doloimo vhodne stopnje tok. 
      Tu seveda tejejo le povezave med razlinimi skupinami! }
    New(InDegS);
    for s := 1 to StSkupin do InDegS^[s] := 0;
    for u := 1 to N do begin
      s := Skupina^[u];
      for i := 1 to OutDeg^[u] do begin
        t := Skupina^[Nasl^[PrviNasl^[u] + i - 1]];
        if t <> s then Inc(InDegS^[t]);
      end; {for i}
    end; {for u}

    { Zdaj moramo le e urediti skupine med sabo. 
      To bomo naredili s topolokim urejanjem. }
    New(Vrsta); Glava := 1; Rep := 1;
    { - Dodajmo v vrsto skupine z vhodno stopnjo 0. }
    for s := 1 to StSkupin do if InDegS^[s] = 0 then
      begin Vrsta^[Rep] := s; Inc(Rep); end;
    { - Preeimo ves graf. }
    while Glava < Rep do begin
      if Glava > 1 then Write(', ');
      s := Vrsta^[Glava]; Inc(Glava);
      u := SkupPrvi^[s]; Write('(');
      { Skupino s zbriimo iz grafa.  Ob tem izpiimo vse
        njene toke, upotevajmo pa tudi, da se zmanjajo
        vhodne stopnje vseh skupin, v katere kaejo toke 
        te skupine.  e pri tem kakni skupini t pade 
        vhodna stopnja na 0, jo dodamo v vrsto. }
      while u <> 0 do begin 
        for i := 1 to OutDeg^[u] do begin
          t := Skupina^[Nasl^[PrviNasl^[u] + i - 1]];
          if t = s then continue;
          Dec(InDegS^[t]);
          if InDegS^[t] = 0 then
            begin Vrsta^[Rep] := t; Inc(Rep); end;
        end; {for}
        if u <> SkupPrvi^[s] then Write(', ');
        Write(u); u := SkupNasl^[u]; 
      end; {while}
      Write(')');
    end; {while}
    Assert(Glava = StSkupin + 1);
    
    Dispose(Vrsta); Dispose(InDegS);
    Dispose(Skupina); Dispose(SkupNasl); Dispose(SkupPrvi);
    Dispose(Pred); Dispose(PrviPred); 
    Dispose(Nasl); Dispose(PrviNasl);
    Dispose(InDeg); Dispose(OutDeg);
    WriteLn;
    
  end; {while not Eof}
end. {RazvrscanjeTekmovalcev}
