program PoletniCas; { RTK 2000.2.1 }

type NizT = packed array[1..64] of char; 

{ Globalne spremenljivke podprograma PolnaMinuta. }
const PrejsnjiOdmikDefiniran: integer = 0; 
var PrejsnjiOdmik: integer; 
    IzpustiliUro, PonavljamoUro: boolean; 
    Seznam: text;
      
procedure Opravi(Opravilo: NizT); forward; 

{ To je podprogram, ki so ga morali napisati tekmovalci. }
procedure PolnaMinuta(UraUTC, Minuta, Odmik: integer); 
var 
  h, m: integer; 
  Opravilo: NizT; 
  Stori: boolean; 
begin
  if PrejsnjiOdmikDefiniran = 0 then 
    begin PrejsnjiOdmik := Odmik; PrejsnjiOdmikDefiniran := 1; end;
  if Minuta = 0 then begin 
    IzpustiliUro := Odmik > PrejsnjiOdmik; 
    PonavljamoUro := Odmik < PrejsnjiOdmik; 
    PrejsnjiOdmik := Odmik; 
  end; {if}
  Reset(Seznam);
  while not Eof(Seznam) do begin 
    ReadLn(Seznam, h, m, Opravilo); 
    if (m < 0) or (m = Minuta) then begin 
      if PonavljamoUro then     { prehod na zimski as } 
        Stori := (h < 0) 
      else if IzpustiliUro then { prehod na poletni as } 
        Stori := (h < 0) or (h = UraUTC + Odmik) or (h = UraUTC + Odmik - 1) 
      else 
        Stori := (h < 0) or (h = UraUTC + Odmik); 
      if Stori then Opravi(Opravilo); 
    end; {if}
  end; {while}
end; {PolnaMinuta} 

{-----------------------------------------------------------------------------}
{ Preostanek programa simulira nekaj razlinih dni v letu                     }
{ in pri tem za vsako minuto po enkrat poklie podprogram PolnaMinuta.        }
{-----------------------------------------------------------------------------}

procedure Opravi(Opravilo: NizT);
begin
  WriteLn(Opravilo);
end; {Opravi}

{ Ta podprogram odsimulira en dan (od polnoi do polnoi, po UTC).
  Odmik = odmik, ki je v veljavi ob zaetku dneva.
  PrehodKdaj = ob kateri uri po lokalnem asu se zgodi prehod.
  PrehodKako = za koliko se sprememni odmik ob prehodu. }
procedure Dan(Odmik, PrehodKdaj, PrehodKako: integer);
var UraUTC, Minuta: integer; Ze: boolean;
begin
  Ze := false; UraUTC := 0; Minuta := 0;
  while UraUTC < 24 do begin
    if ((UraUTC + Odmik) mod 24 = PrehodKdaj) and not Ze then 
      begin Inc(Odmik, PrehodKako); Ze := true; end;
    WriteLn(UraUTC div 10, UraUTC mod 10, ':', 
            Minuta div 10, Minuta mod 10, ' + ', Odmik);
    PolnaMinuta(UraUTC, Minuta, Odmik);
    Inc(Minuta);
    if Minuta = 60 then begin Inc(UraUTC); Minuta := 0; end;
  end; {while}
end; {Dan}

begin {PoletniCas}
  if ParamCount >= 1 then Assign(Seznam, ParamStr(1))
  else Assign(Seznam, 'rtk00s2n1.in');
  Reset(Seznam);
  
  Dan(1, 0, 0); { zima }
  Dan(1, 2, 1); { pomlad }
  Dan(2, 0, 0); { poletje }
  Dan(2, 3, -1); { jesen }
  Dan(1, 0, 0); { zima }
  
  Close(Seznam);
end. {PoletniCas}

