program Stopnisce; { RTK 2001.1.2 }
uses Crt;

  { Vmesnik, ki ga vidi podprogram za upravljanje avtomata. }
  function TipkaloPritisnjeno: boolean; forward;
  procedure Vklopi; forward;
  procedure Izklopi; forward;
  procedure Pocakaj1ms; forward;

{ Podprogram za upravljanje s stopninim avtomatom.
  Tega so morali napisati tekmovalci. }
procedure StopniscniAvtomat; 
var TipkaloNovo, TipkaloStaro: boolean; 
    Vkljuceno: boolean;       { stanje lui } 
    PreostaliCas: integer;    { as do izklopa v milisekundah } 
begin {StopniscniAvtomat} 
  Izklopi; Vkljuceno := false; 
  TipkaloStaro := false; PreostaliCas := 0; 
  repeat 
    TipkaloNovo := TipkaloPritisnjeno; 
    if TipkaloNovo and not TipkaloStaro then 
    begin { zaetek pritiska tipke } 
      if Vkljuceno then Izklopi else Vklopi; 
      Vkljuceno := not Vkljuceno; 
    end; {if}
    TipkaloStaro := TipkaloNovo; 
    if not Vkljuceno then PreostaliCas := 0 
    else if TipkaloNovo then PreostaliCas := 5000; 
    if PreostaliCas > 0 then PreostaliCas := PreostaliCas - 1 
    else if Vkljuceno then begin Izklopi; Vkljuceno := false; end;
    Pocakaj1ms; 
  until false; 
end; {StopniscniAvtomat} 

{-----------------------------------------------------------------------------}
{ Preostanek programa deluje kot simulator dogajanja na stopniu.
  Uporabnik lahko s pritiskom na tipko 1 poloi roko na tipkalo,
  s pritiskom na tipko 2 jo dvigne, s pritiskom na 0 pa kona
  z izvajanjem programa.  Program med tem na zaslon prikazuje
  stanje tipkala in lui. }
{-----------------------------------------------------------------------------}
  
var 
  { Trenutno stanje tipkala in lui. }
  Pritisnjeno, Prizgana: boolean;
  { Spremenljivka Cas teje as v milisekundah.
    CasTipkala in CasLuci povesta, kdaj sta tipkalo in lu
    dosegla svoje trenutno stanje. }
  Cas, CasTipkala, CasLuci: longint;

function TipkaloPritisnjeno: boolean;
begin
  TipkaloPritisnjeno := Pritisnjeno;
end; {TipkaloPritisnjeno}

procedure Vklopi;
begin
  if not Prizgana then 
    begin Prizgana := true; CasLuci := Cas; end;
end; {Vklopi}

procedure Izklopi;
begin
  if Prizgana then 
    begin Prizgana := false; CasLuci := Cas; end;
end; {Izklopi}

procedure PrikaziStanje;
begin
  Write('Tipkalo ');
  if Pritisnjeno then Write('pritisnjeno')
  else Write('spueno   ');
  Write(' ', (0.001 * (Cas - CasTipkala)):6:1, ' s, lu ');
  if Prizgana then Write('prigana ')
  else Write('ugasnjena');
  Write(' ', (0.001 * (Cas - CasLuci)):6:1, ' s', Chr(13));
end; {Pocakaj1ms}

procedure Pocakaj1ms;
begin
  Inc(Cas); 
  { Tule bi zdaj morali klicati Delay(1), da bi program
    poakal eno milisekundo.  Da pa bi simulacijo malce
    pospeili, ga bomo klicali bolj poredko. }
  if (Cas mod 5) = 0 then Delay(1);
  if KeyPressed then 
    case ReadKey of
    '1': if not Pritisnjeno then
      begin Pritisnjeno := true; CasTipkala := Cas; end;
    '2': if Pritisnjeno then
      begin Pritisnjeno := false; CasTipkala := Cas; end;
    '0': begin WriteLn; Halt; end;
    end; {case}
  if Cas mod 100 = 0 then PrikaziStanje;
end;

begin {Stopnisce}
  WriteLn('Simulacija stopninega avtomata');
  WriteLn('Tipka 1 pritisne tipkalo, tipka 2 spusti tipkalo, tipka 0 kona simulacijo.');
  Cas := 0; Pritisnjeno := false; Prizgana := false;
  CasTipkala := Cas; CasLuci := Cas;
  PrikaziStanje; { zaetno stanje }
  StopniscniAvtomat; { poenimo simulacijo }
end. {Stopnisce}
