program Kletke2; { RTK 2001.3.4 z gozdom za disjunktne mnoice }
{ as izvajanja na 16 testnih primerih: 0.42 s }

{ This too I know -- and wise it were
    If each could know the same --
  That every prison that men build
    Is built with bricks of shame,
  And bound with bars lest Christ should see
    How men their brothers maim. 
                       Wilde. }
                       
const MaxM = 100; Zgoraj = 1; Levo = 8;
var 
  { Velikost[k] = velikost (skupno tevilo celic) kletke k }
  Velikost: array[1..MaxM] of integer;
  { VTejVrsti[k] = koliko elementov tabele Kletka ima trenutno vrednost k }
  VTejVrsti: array[1..MaxM] of integer; 
  { Kletka[x] = kletka, ki ji pripada celica x }
  Kletka: array[1..MaxM] of integer; 
  { NadKletka[k] = kletka, katere del je postala kletka k med zlivanjem }
  NadKletka: array[1..MaxM] of integer; 
  { sklad neuporabljenih tevilk kletk, torej takih, 
    na katere ne kae noben element tabele Kletka }
  StProstih: integer; Proste: array[1..MaxM] of integer;
  { statistike, ki jih bomo morali na koncu izpisati }
  Najvecja, Najmanjsa, StKletk: integer;
  { M = irina mree, N = viina }
  M, N: integer;

  { Zmanja VTejVrsti[k] za 1.  e pri tem pade na 0, kletko pobrie. }
  procedure ZmanjsajKletko(k: integer);
  begin
    VTejVrsti[k] := VTejVrsti[k] - 1; 
    if VTejVrsti[k] > 0 then exit;
    if NadKletka[k] = k then begin
      { To je bila res samostojna kletka, ne pa del kakne
        veje.  Zato osveimo statistike. }
      if Velikost[k] > Najvecja then Najvecja := Velikost[k];
      if Velikost[k] < Najmanjsa then Najmanjsa := Velikost[k];
      StKletk := StKletk + 1;
    end; {if}
    { Ta tevilka kletke je zdaj prosta in jo bomo lahko uporabili 
      za kakno novo kletko. }
    StProstih := StProstih + 1; Proste[StProstih] := k;
  end; {ZmanjsajKletko}

  { Pove, v katero kletko spada celica x, in popravi kazalce na
    poti do te kletke, da kaejo naravnost nanjo in ne na podkletke. }  
  function NajdiKletko(x: integer): integer;
  var k, Nad, r: integer;
  begin
    r := Kletka[x];
    while NadKletka[r] <> r do r := NadKletka[r];
    { Preveimo kazalce na poti do r, da bodo kazali naravnost na r.
      Tudi celica x naj odslej kae naravnost na r. }
    k := Kletka[x];
    if k <> r then begin 
      Nad := NadKletka[k]; ZmanjsajKletko(k); k := Nad; 
      Kletka[x] := r; VTejVrsti[r] := VTejVrsti[r] + 1; 
      while k <> r do begin Nad := NadKletka[k]; NadKletka[k] := r; k := Nad; end; 
    end; {if}
    NajdiKletko := r;
  end; { NajdiKletko }

  { Zlije dani kletki -- manja postane podkletka veje. }  
  function ZlijKletki(k1, k2: integer): integer;
  var k: integer;
  begin
    if Velikost[k1] < Velikost[k2] then k := k2 else k := k1;
    NadKletka[k1] := k; NadKletka[k2] := k; 
    Velikost[k] := Velikost[k1] + Velikost[k2];
    ZlijKletki := k;
  end; {ZlijKletki}
  
var T: text; Celica, y, x, k: integer;
begin
  { Preberimo velikost mree. }
  if ParamCount > 0 then Assign(T, ParamStr(1)) else Assign(T, 'kletke.in'); 
  Reset(T); ReadLn(T, M, N);
  { Nikoli ne bo hkrati 'odprtih' ve kot M kletk.  Zato bomo
    za kletke vedno uporabljali tevila od 1 do M.  Tista, ki
    trenutno niso uporabljena za nobeno kletko, hranimo v seznamu. }
  StProstih := M; for k := 1 to M do Proste[k] := k;
  { Preglejmo celo mreo. }
  Najvecja := 0; Najmanjsa := M * N; StKletk := 0;
  for y := 1 to N do begin
    for x := 1 to M do begin
      Read(T, Celica); Celica := Celica and (Zgoraj or Levo);
      if Celica = 0 then begin
        { Celica ima zidova zgoraj in levo; ustanovimo zanjo novo kletko. }
        if y > 1 then ZmanjsajKletko(Kletka[x]);
        k := Proste[StProstih]; StProstih := StProstih - 1; 
        Velikost[k] := 1; VTejVrsti[k] := 1; NadKletka[k] := k; Kletka[x] := k;
      end else if Celica = Zgoraj then begin
        { Celica pripada isti kletki kot tista nad njo. }
        k := NajdiKletko(x); { to je e tudi postavilo Kletka[x] na k in popravilo VTejVrsti[k] }
        Velikost[k] := Velikost[k] + 1;
      end else if Celica = Levo then begin
        { Celica pripada isti kletki kot tista levo od nje. }
        if y > 1 then ZmanjsajKletko(Kletka[x]);
        { Spomnimo se, da Kletka[x - 1] zdaj e kae na pravo kletko, ne na
          kakno podkletko, saj smo imeli ravno v prejnji iteraciji opraviti
          s tisto celico in smo zato gotovo poskrbeli, da je takrat kazala
          na pravo kletko; medtem pa se ta kletka tudi ni imela asa s im zliti. 
          Zato ni treba klicati NajdiKletko(x - 1). }
        k := Kletka[x - 1]; Kletka[x] := k; 
        VTejVrsti[k] := VTejVrsti[k] + 1; Velikost[k] := Velikost[k] + 1;
      end else begin
        { Zlijmo kletko nad njo in tisto levo od nje
          (e nista to e zdaj ena in ista kletka). }
        k := NajdiKletko(x); { e tudi popravi Kletka[x] }
        if Kletka[x - 1] <> k then begin { sta razlini --> bo treba zlivati }
          k := ZlijKletki(Kletka[x - 1], k);
          if Kletka[x] <> k then begin
            { Element Kletka[x] se bo spremenil na k, zato ima dosedanja 
              kletka Kletka[x] eno referenco manj, k pa eno ve. }
            ZmanjsajKletko(Kletka[x]); 
            Kletka[x] := k; VTejVrsti[k] := VTejVrsti[k] + 1;
          end; {if}
        end; {if}
        Velikost[k] := Velikost[k] + 1;
      end; {if}
    end; {for x}
    ReadLn(T);
  end; {for y}
  Close(T);
  { Zakljuimo celice zadnje vrstice. }
  for x := 1 to M do ZmanjsajKletko(Kletka[x]); 
  { Izpiimo rezultate. }
  if ParamCount > 1 then Assign(T, ParamStr(2)) else Assign(T, 'kletke.out'); 
  Rewrite(T); WriteLn(T, StKletk); WriteLn(T, Najmanjsa); WriteLn(T, Najvecja); Close(T);
end. {Kletke2}
