program Crpalke; { RTK 2002.1.4 }
{ Ta reitev vsebuje med drugim dva naina za doloanje
  naslednje rpalke: naivnega, igar asovna zahtevnost je
  v najslabem primeru lahko O(n^2), in malo elegantneji
  postopek s skladom, ki zagotavlja asovno zahtevnost O(n).
  e je pri prevajanju definiran simbol SKLAD, se uporabi
  razliica s skladom, sicer pa naivna razliica. }

const MaxN = 100; { Najveje mono tevilo rpalk. } 
var
  { Kje = poloaj rpalk; Cena = cena goriva na njih. }
  Kje, Cena: array[1..MaxN] of real;
  Poraba: real;    { Poraba goriva v litrih na 100 km. } 
  Posoda: real;    { Velikost posode za gorivo v litrih. } 
  Pot: real;       { Skupna dolina poti v kilometrih. } 
  N, i, j: integer; Gorivo, Razd, Koliko: real; T: text;
{$IFDEF SKLAD}
  Sklad, Nasl: array[1..MaxN] of integer;  
{$ENDIF}

begin
  { Preberimo vhodne podatke. 
    Oblika vhodne datoteke: Pot; Posoda; Poraba; N; 
    Kje[1] Cena[1]; ...; Kje[N] Cena[N]. }
  if ParamCount >= 1 then Assign(T, ParamStr(1))
  else Assign(T, 'rtk02s1n4.in');
  Reset(T); ReadLn(T, Pot); ReadLn(T, Posoda);
  ReadLn(T, Poraba); ReadLn(T, N);
  for i := 1 to N do ReadLn(T, Kje[i], Cena[i]);
  Close(T);

{$IFDEF SKLAD}
  { Za vsako rpalko ugotovimo, katera je prva ceneja 
    za njo na poti.  rpalke, za katere e nismo nali
    naslednje ceneje, hranimo na skladu, urejene po ceni
    (draje bolj pri vrhu, ceneje bolj pri dnu). }
  j := 0; { j je tevilo elementov na skladu. }
  for i := 1 to N do begin
    { rpalka i je mogoe ceneja od nekaterih na skladu;
      tako bomo zanje ugotovili, katera je naslednja ceneja od njih.
      e je i ceneja sploh od katere, je gotovo od najdrajih,
      torej od tistih pri vrhu sklada. } 
    while j > 0 do 
      if Cena[Sklad[j]] <= Cena[i] then break
      else begin Nasl[Sklad[j]] := i; Dec(j); end; 
    { Zdaj pa dodajmo na sklad e i, kar je znak, da tudi
      zanjo iemo naslednjo cenejo rpalko. }
    Inc(j); Sklad[j] := i;
  end; {for}
  { Na skladu so ostale le rpalke brez naslednje ceneje. } 
  while j > 0 do 
    begin Nasl[Sklad[J]] := N + 1; Dec(j); end; 
{$ENDIF}

  { Glavni del programa. }
  Gorivo := 0; i := 1; 
  while i <= N do begin 

    { Trenutno se nahajamo na rpalki i in imamo 'Gorivo' litrov 
      goriva.  Naj bo j naslednja ceneja rpalka.  e take
      ni, naj bo j enak N + 1 -- uinek je tak, kot da bi nas
      na koncu poti akalo brezplano gorivo. }
{$IFDEF SKLAD}  
    j := Nasl[i]; 
{$ELSE}
    j := i + 1;
    while j <= N do 
      if Cena[j] < Cena[i] then break
      else j := j + 1; 
{$ENDIF}

    { Kako dale je do rpalke j? }
    if j > N then Razd := Pot - Kje[i] 
    else Razd := Kje[j] - Kje[i]; 
    { Koliko goriva potrebujemo za pot do tam? } 
    Koliko := (Razd / 100.0) * Poraba; 
    WriteLn('Smo na ', i, ' z ', Gorivo:0:2, ' l; naslednja ceneja je ',
            j, ' (do koder potrebujemo ', Koliko:0:2, ' l).');

    if Gorivo < Koliko then begin 
      { Treba bo dotoiti. } 
      if Koliko <= Posoda then begin 
        { Natoimo dovolj za pot do j. } 
        WriteLn('Na rpalki ', i, ' dotoimo ', (Koliko - Gorivo):0:2, ' l.'); 
        Gorivo := 0; i := j; 
      end else begin 
        { Natoimo poln tank, pa e ne bo dovolj do j. } 
        WriteLn('Na rpalki ', i, ' dotoimo ', (Posoda - Gorivo):0:2, ' l.'); 
        { Zapeljimo se do naslednje rpalke -- i poveajmo za 1.
          Tam se bomo potem naprej ubadali z vpraanjem goriva.
          Z vidika rpalke i+1 namre naslednja ceneja mogoe ni j,
          pa pa neka druga rpalka med i+1 in j; zato se bo na i+1
          mogoe splaalo natoiti nekaj goriva, ipd. }
        Gorivo := Posoda - ((Kje[i + 1] - Kje[i]) / 100.0) * Poraba; 
        i := i + 1; 
      end; {if}
    end else begin 
      { Imamo dovolj goriva za do j. } 
      Gorivo := Gorivo - Koliko; i := j; 
    end; {if}
    
  end; {while i <= N}
end. {Crpalke} 
