program ZunanjaPolitika; { RTK 2002.2.2 }

  const MaxN = 100; 
  type KdoJeKdo = (Neznanec, Prijatelj, Sovrag); 
  { Odnos[i, j] = kaj je oseba j osebi i }
  var Odnos: array[0..MaxN - 1, 0..MaxN - 1] of KdoJeKdo; 

var Prij, Sovr: array[0..MaxN - 1] of boolean; 
    Seznam: array[0..2 * MaxN - 1] of integer; 
    i, j, x, Dolzina, N: integer; Dodaj: boolean; T: text;
begin

  { Preberimo vhodne podatke.  V prvi vrstici mora biti 
    N (tevilo oseb), sledi pa naj N vrstic s po N vrednostmi
    -1, 0 in 1, s katerimi se napolni tabela Odnos. }
  if ParamCount >= 1 then Assign(T, ParamStr(1))
  else Assign(T, 'rtk02s2n2.in');
  Reset(T); ReadLn(T, N);
  for i := 0 to N - 1 do begin
    for j := 0 to N - 1 do begin
      Read(T, x);
      if x = 1 then Odnos[i, j] := Prijatelj
      else if x = -1 then Odnos[i, j] := Sovrag
      else Odnos[i, j] := Neznanec;
    end; {for j}
    ReadLn(T);
  end; {for i}
  Close(T);
  
  { Na zaetku e za nikogar ne vemo, e je na
    prijatelj ali sovranik. }
  for i := 0 to N - 1 do 
    begin Prij[i] := false; Sovr[i] := false; end; 
  { V tabeli Seznam bomo hranili osebe, za katere smo na
    novo izvedeli, da so prijatelji ali pa sovraniki osebe 0
    in moramo zato pregledati tudi njihove neposredne
    prijatelje in sovranike, ker lahko zdaj tudi o teh
    ugotovimo, v kaknem odnosu so z osebo 0.  Na zaetku
    postavimo v seznam osebo 0 samo in oznaimo, da je sama 
    sebi prijatelj. }
  Seznam[0] := 0; Dolzina := 1; Prij[0] := true; 
  while Dolzina > 0 do begin 
    { Vzemimo neko osebo iz seznama.  Vzeli bomo kar tisto
      s konca, tako da Seznam pravzaprav deluje kot sklad,
      vendar pa bi lahko vzeli tudi katero koli drugo. }
    Dec(Dolzina); i := Seznam[Dolzina];  
    for j := 0 to N - 1 do begin 
      Dodaj := false; 
      { Neposredni prijatelji naih prijateljev ter neposredni
        sovraniki naih sovranikov so nai prijatelji. }
      if ((Prij[i] and (Odnos[i, j] = Prijatelj)) or 
          (Sovr[i] and (Odnos[i, j] = Sovrag))) and not Prij[j] then
        begin Prij[j] := true; Dodaj := true; end; 
      { Neposredni sovraniki naih prijateljev ter neposredni
        prijatelji naih sovranikov so nai sovraniki. }
      if ((Prij[i] and (Odnos[i, j] = Sovrag)) or 
          (Sovr[i] and (Odnos[i, j] = Prijatelj))) and not Sovr[j] then
        begin Sovr[j] := true; Dodaj := true; end; 
      { e smo o osebi j izvedeli kaj novega, jo dodajmo v
        seznam, da si bomo o priliki ogledali e njene
        neposredne prijatelje in sovranik.e }
      if Dodaj then begin Seznam[Dolzina] := j; Inc(Dolzina); end; 
    end; {for}
  end; {while}

  { Izpiimo rezultate. }
  WriteLn('Pravi prijatelji:'); 
  for i := 1 to N - 1 do 
    if Prij[i] and not Sovr[i] then WriteLn(i); 
  WriteLn('Pravi sovraniki:'); 
  for i := 1 to N - 1 do 
    if Sovr[i] and not Prij[i] then WriteLn(i); 
end. {ZunanjaPolitika} 
