program ZadnjaNenicelnaStevka; { RTK 2003.2.2 }

type RezultatT = array[1..9] of integer; 

procedure Stevke(M, N: integer; var Rezultat: RezultatT); 
var i, d: integer; R: RezultatT; 
begin
  for i := 1 to 9 do Rezultat[i] := 0; 
  { Premaknimo M naprej in N nazaj do najblijih
    vekratnikov tevila 10. }
  while (M mod 10 <> 0) and (M <= N) do 
    begin Inc(Rezultat[M mod 10]); Inc(M); end; 
  while (N mod 10 <> 0) and (M <= N) do 
    begin Inc(Rezultat[N mod 10]); Dec(N); end; 
  { Zdaj sta M in N vekratnika 10.  Naj bo d := (N - M)/10.
    Na intervalu M..N - 1 se torej pojavi d tevil z zadnjo 
    tevko i, in to za vsak i od 0 do 9.  Za i = 1, ..., 9 
    jih lahko torej kar pritejemo v Rezultat, za i = 0 pa 
    imajo tista tevila, pa tudi N sam, isto zadnjo nenielno 
    tevko, kot e bi jih vsa delili z 10, to pa nam da 
    interval (M div 10)..(N div 10). }
  if M <= N then begin
    Stevke(M div 10, N div 10, R); 
    for i := 1 to 9 do Inc(Rezultat[i], R[i]); 
    d := (N - M) div 10;     
    for i := 1 to 9 do Inc(Rezultat[i], d); 
  end; {if}
end; {Stevke} 

{ Naivna reitev -- z zanko se sprehodimo po vseh
  tevilih od M do N in pri vsakem posebej doloimo
  zadnjo nenielno tevko. }
procedure Stevke2(M, N: integer; var Rezultat: RezultatT); 
var i, j: integer; 
begin
  for i := 1 to 9 do Rezultat[i] := 0; 
  for i := M to N do begin 
    { Zadnja tevka tevila i je i mod 10.  e je to
      enako 0, bomo i delili z 10 (s tem zadnjo tevko
      zbriemo) in vse skupaj ponovili.  Vendar pa i-ja
      samega ne smemo spreminjati, saj ga uporablja tudi
      zanka for.  Zato uporabimo pomono spremenljivko j. }
    j := i; while j mod 10 = 0 do j := j div 10; 
    Inc(Rezultat[j mod 10]); 
  end; {for}
end; {Stevke2} 

var M, N, i: integer; R: RezultatT; 
begin {ZadnjaNenicelnaStevka}
  if ParamCount >= 2 then begin
    Val(ParamStr(1), M, i); Val(ParamStr(2), N, i);
    WriteLn('M = ', M, ', N = ', N);
  end else begin
    Write('Vnesi M in N: '); 
    ReadLn(M, N);
  end; {if}
  { Poenimo obe razliici reitve.  
    Obe morata dati enak rezultat. }
  Stevke(M, N, R); 
  for i := 1 to 9 do if R[i] > 0 then Write(i, ':', R[i], ' ');  
  WriteLn; Stevke2(M, N, R); 
  for i := 1 to 9 do if R[i] > 0 then Write(i, ':', R[i], ' ');  
  WriteLn; 
end. {ZadnjaNenicelnaStevka}
