program Ploscice; { RTK 2004.1.2 }

{-----------------------------------------------------------------------------}
{ Implementacija funkcij, za katere naloga pravi, da smemo predpostaviti,     }
{ da e obstajajo.  Podprogram Inicializacija prebere podatke o ploicah     }
{ iz vhodne datoteke, ki naj ima naslednjo obliko:                            }
{                                                                             }
{ nVrstic                                                                     }
{ nPloscic[1] Sirine[1, 1] Sirine[1, 2] ... Sirine[1, nPloscic[1]]            }
{ nPloscic[2] Sirine[2, 1] Sirine[2, 2] ... Sirine[2, nPloscic[2]]            }
{ . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .           }
{ nPloscic[nVrstic] Sirine[nVrstic, 1] ... Sirine[nVrstic, nPloscic[nVrstic]] }
{ Zacetna                                                                     }
{                                                                             }
{ Ime te datotek priakuje program kot parameter na vhodni vrstici.           }
{-----------------------------------------------------------------------------}

const 
  MaxVrstic = 100; 
  MaxPloscic = 100; { na vrstico }
var 
  nVrstic: integer;
  nPloscic: array [1..MaxVrstic] of integer;
  Sirine: array [1..MaxVrstic, 1..MaxPloscic] of integer;
  Zacetna: integer;

function StVrstic: integer;
begin
  StVrstic := nVrstic;
end; {StVrstic}

function StPloscic(StVrstice: integer): integer;
begin
  Assert(1 <= StVrstice); Assert(StVrstice <= nVrstic);
  StPloscic := nPloscic[StVrstice];
end; {StPloscic}

function SirinaPloscice(StVrstice, StPloscice: integer): integer;
begin
  Assert(1 <= StVrstice); Assert(StVrstice <= nVrstic);
  Assert(1 <= StPloscice); Assert(StPloscice <= nPloscic[StVrstice]);
  SirinaPloscice := Sirine[StVrstice, StPloscice];
end; {SirinaPloscice}

function ZacetnaPloscica: integer;
begin
  ZacetnaPloscica := Zacetna;
end; {ZacetnaPloscica}

function Inicializacija: boolean;
var T: text; i, j: integer;
begin
  if ParamCount < 1 then begin
    WriteLn('Kot parameter podajte ime datoteke s podatki o ploicah.');
    Inicializacija := false; exit;
  end; {if}
  Assign(T, ParamStr(1)); Reset(T);
  Read(T, nVrstic);
  for i := 1 to nVrstic do begin
    Read(T, nPloscic[i]);
    for j := 1 to nPloscic[i] do Read(T, Sirine[i, j]);
  end; {for i}
  Read(T, Zacetna);
  Close(T);
  Inicializacija := true;
end; {Inicializacija}

{-----------------------------------------------------------------------------}
{ Od tu naprej je tisti del reitve, ki naj bi jo napisali tekmovalci.        }
{-----------------------------------------------------------------------------}

var xOd, xDo, xOdPrej, xDoPrej, x, xx, y, i, iOd, iDo: integer;
begin
  if not Inicializacija then exit;
  
  x := 0;
  for i := 1 to ZacetnaPloscica - 1 do x := x + SirinaPloscice(1, i);
  xOd := x; xDo := xOd + SirinaPloscice(1, ZacetnaPloscica);
  iOd := ZacetnaPloscica; iDo := ZacetnaPloscica;
  
  WriteLn('1. vrstica: plosce ', iOd, '..', iDo, ', x = ', xOd, '..', xDo);
  
  for y := 2 to StVrstic do begin
    xOdPrej := xOd; xDoPrej := xDo; iOd := 0; x := 0;
    
    for i := 1 to StPloscic(y) do begin
      xx := x + SirinaPloscice(y, i);
      { Trenutna ploica pokriva x-koordinate od x do xx. }
      if (x < xDoPrej) and (xx > xOdPrej) then begin
        iDo := i; xDo := xx;
        if iOd = 0 then begin iOd := i; xOd := x end;
      end; {if}
      x := xx;
    end; {for i}

    WriteLn(y, '. vrstica: plosce ', iOd, '..', iDo, ', x = ', xOd, '..', xDo);
  end; {for y}
  
  WriteLn('V zadnji vrstici so dosegljive ploice ', iOd, '..', iDo, '.');
end. {Ploscice}
