program Sbn; { RTK 2004.3.2 }
var T: text; { izhodna datoteka }
    Temp: integer; { pomoni register }

{ Urejanje s kopico (heap sort)  Za urejanje n registrov dobimo zaporedje
  priblino n^2 ukazov, pri izvajanju pa se izvede O(n log n) korakov.
  Podrobneji opis urejanja s kopico lahko najdemo na internetu 
  in v tevilnih ubenikih algoritmov in podatkovnih struktur. }

  { Podprogram Pogrezanje poskrbi za pogrezanje elementa r znotraj kopice a[1..m].
    Niz 'Lab' se uporablja pri labelah.  Za vsako notranje
    vozlie zgeneriramo 8 ukazov (oz. 3, e ima samo enega otroka).
    Ker je notranjih vozli priblino polovica, je to priblino 4m ukazov. 
    Celoten heapsort potrebuje zato priblino 4m(m-1)/2 = priblino 2 m^2 ukazov.  
    
    Za potrebe priredbe v SBN zapiimo postopek pogrezanja takole:
      i := koren; 
      while i <= m div 2 do begin   -- ponavljajmo, dokler ne pridemo do lista
        c1 := 2 * i; c2 := c1 + 1;  -- otroka elementa i
        if r[c1] >= r[c2] then begin
          if e >= r[c1] then break
          else begin zamenjaj r[i] in r[c1]; i := c1 end;
        end else begin
          if r[i] >= r[c2] then break
          else begin zamenjaj r[i] in r[c2]; i := c2 end;
        end;
      end; 
    
    (Dodati bi morali e posebno obravnavo primera, ko je c1 = m in
    ima torej element i samo enega otroka.)  
    
    Kakorkoli e, mi bomo morali za vsako vrednost i-ja zgenerirati po
    en izvod telesa zanke.  Namesto spreminjanja i-ja in stavkov break
    bomo imeli stavke goto:
    
      lab_i:   c1 := 2 * i; c2 := c1 + 1;
               if r[c1] >= r[c2] then begin
                 if e >= r[c1] then goto lab_konec
                 else begin
                   zamenjaj r[i] in r[c1];
                   e je c1 notranje vozlie, skoi na lab_c1, sicer na lab_konec;
                 end
               else begin
                 if r[i] >= r[c2] then goto lab_konec
                 else begin
                   zamenjaj r[i] in r[c2];
                   e je c2 notranje vozlie, skoi na lab_c2, sicer na lab_konec;
                 end
               end;

    Po en tak izvod zanke potrebujemo za vsak element i v poddrevesu
    s korenom pri r.  lab_konec naj bo neka labela na koncu, na katero
    lahko skoimo, ko je pogrezanje konano. }
    
  procedure Pogrezanje(r, m: integer; Lab: string);
  
    procedure Rekurzija(i: integer);
    var c1, c2: integer;
    begin
      Assert(i <= m div 2); { notranje vozlie }
      c1 := 2 * i; c2 := c1 + 1;
      if r <> i then Write(T, 'c_', Lab, '_', r, '_', m, '_', i, ': ');
      if c2 <= m then begin
        { Primerjajmo r[c1] in r[c2]. }
        WriteLn(T, 'sbn r', Temp, ', r', c1, ', r', c2, ', s_', Lab, '_', r, '_', m, '_', i);
        { r[c1] >= r[c2].  Primerjajmo r[i] in r[c1]. }
        WriteLn(T, 'sbn r', Temp, ', r', c1, ', r', i, ', a_', Lab, '_', r, '_', m);
        { r[c1] < r[i], zamenjajmo ju in postavimo i := c1. }
        WriteLn(T, 'sbn r', i, ', r', c1, ', 0'); { r[i] := r[c1] }
        WriteLn(T, 'sbn r', c1, ', r', c1, ', r', Temp, ''); { r[c1] := r[c1] - (r[c1] - old r[i]); }
        { Zdaj moramo nadaljevati pri i = c1; v ta namen izvedemo rekurzivni klic,
          da bo zgeneriral ustrezne ukaze.  e pa je c1 list, pa je pogrezanja
          konec in moramo le skoiti na primerno labelo. }
        if c1 > m div 2 then WriteLn(T, 'sbn r', Temp, ', 0, 1, a_', Lab, '_', r, '_', m)
        else Rekurzija(c1);
        { r[c1] < r[c2].  Primerjajmo r[i] in r[c2]. }
        Write(T, 's_', Lab, '_', r, '_', m, '_', i, ': ');
        WriteLn(T, 'sbn r', Temp, ', r', c2, ', r', i, ', a_', Lab, '_', r, '_', m);
        { r[c2] < r[i], zamenjajmo ju in postavimo i := c2. }
        WriteLn(T, 'sbn r', i, ', r', c2, ', 0'); { r[i] := r[c2] }
        WriteLn(T, 'sbn r', c2, ', r', c2, ', r', Temp, ''); { r[c2] := r[c2] - (r[c2] - old r[i]); }
        { Nadaljujmo z rekurzivnim klicem, e pa je c2 list, je pogrezanja konec. }
        if c2 > m div 2 then WriteLn(T, 'sbn r', Temp, ', 0, 1, a_', Lab, '_', r, '_', m)
        else Rekurzija(c2);
      end
      else begin
        Assert(c1 <= m); Assert(c1 > m div 2);
        { i ima samo enega otroka, c1 (ki je list).  Primerjajmo ju. }
        WriteLn(T, 'sbn r', Temp, ', r', c1, ', r', i, ', a_', Lab, '_', r, '_', m);
        { r[c1] < r[i], zamenjajmo ju in postavimo i := c1. }
        WriteLn(T, 'sbn r', i, ', r', c1, ', 0'); { r[i] := r[c1] }
        WriteLn(T, 'sbn r', c1, ', r', c1, ', r', Temp, ''); { r[c1] := r[c1] - (r[c1] - old r[i]); }
        if c1 > m div 2 then WriteLn(T, 'sbn r', Temp, ', 0, 1, a_', Lab, '_', r, '_', m)
      end; {if}
    end; {Rekurzija}
  
  begin
    { Notranja vozlisca so 1..(m div 2). }
    if r <= m div 2 then Rekurzija(r);
    Write(T, 'a_', Lab, '_', r, '_', m, ': ');
  end; {Sift}

var i, n: integer;
begin
  if ParamCount >= 1 then Assign(T, ParamStr(1)) else Assign(T, 'sbn.in');
  Reset(T); ReadLn(T, n); Close(T);
  if ParamCount >= 2 then Assign(T, ParamStr(2)) else Assign(T, 'sbn.out');
  Rewrite(T);
  Temp := n + 1;
  { Organizirajmo podatke v kopico (heapify) -- O(n log n) ukazov. }
  for i := n div 2 downto 1 do Pogrezanje(i, n, 'H'); 
  { Urejanje -- priblino 2n^2 ukazov. }
  for i := n downto 2 do begin
    { Zamenjaj r[1] in r[i]. }
    WriteLn(T, 'sbn r', Temp, ', r', i, ', 0');
    WriteLn(T, 'sbn r', i, ', r1, 0');
    WriteLn(T, 'swap_', i, ': sbn r1, r', Temp, ', 0');
    { Popravi kopico. }
    Pogrezanje(1, i - 1, 'S');
  end; {for}
  WriteLn(T, 'sbn r', Temp, ', r', Temp, ', r', Temp, ''); { NOP zaradi zadnje labele }
  Close(T);
end. {Sbn}
