program Butalci; { RTK 2004.3.3 }

{ "Naivna" reitev (z rekurzijo).  Pri vejih testnih primerih
  lahko porabi eksponentno mnogo asa. }

const 
  MaxNB = 25; { najveje tevilo Butalcev }
  MaxNT = 500000; { najveje tevilo trgovcev }
  MaxVsotaCen = 1000000000; { vsota vseh cen v datoteki }
var 
  NB, NT: integer;
  NK, SkupajNK: array [1..MaxNT] of integer;
  Cene: array [0..MaxNT, 0..MaxNB] of integer;
  MinCena: integer;
  
  procedure Rekurzija(CenaDoslej, TrgovciOd, OstaloKosov: integer);
  var i, Cena: integer;
  begin
    i := 0;
    while (i <= OstaloKosov) and (i <= NK[TrgovciOd]) do begin
      Cena := CenaDoslej + Cene[TrgovciOd, i];
      if Cena < MinCena then begin
        if i = OstaloKosov then MinCena := Cena
        else if TrgovciOd < NT then if SkupajNK[TrgovciOd + 1] >= OstaloKosov - 1 then 
          Rekurzija(Cena, TrgovciOd + 1, OstaloKosov - i);
      end; {if}
      i := i + 1;
    end; {while}
  end; {Rekurzija}
  
var 
  T: text; 
  it, ip, Cena: integer;
begin {Butalci}
  if ParamCount >= 1 then Assign(T, ParamStr(1)) else Assign(T, 'pamet.in');
  Reset(T); 
  ReadLn(T, NB, NT);
  Assert(1 <= NB); Assert(NB <= MaxNB); Assert(1 <= NT); Assert(NT <= MaxNT);
  for it := 1 to NT do begin
    Cene[it, 0] := 0;
    Read(T, NK[it]);
    for ip := 1 to NK[it] do begin
      Read(T, Cena);
      if ip <= NB then Cene[it, ip] := Cene[it, ip - 1] + Cena;
    end; {for}
    Assert(Eoln(T)); ReadLn(T);
  end; {for}
  
  SkupajNK[NT] := NK[NT];
  for it := NT - 1 downto 1 do 
    SkupajNK[it] := SkupajNK[it + 1] + NK[it];
  
  MinCena := MaxVsotaCen + 1;
  Rekurzija(0, 1, NB);

  { Izpiimo rezultat. }
  if ParamCount >= 2 then Assign(T, ParamStr(2)) else Assign(T, 'pamet.out');
  Rewrite(T); WriteLn(T, MinCena); Close(T);
end. {Butalci}
