program CezarjevKod; { RTK 2004.X }
const n = Ord('Z') - Ord('A') + 1;

function StevilkaCrke(Crka: char): integer;
begin 
  StevilkaCrke := Ord(Crka) - Ord('A') + 1;
end; {StevilkaCrke}

function CrkaIzStevilke(Stevilka: integer): char;
begin
  CrkaIzStevilke := Chr(Stevilka + Ord('A') - 1);
end; {CrkaIzStevilke}

function Kodiraj(Niz: string; Kljuc: integer): string;
var Kodiran: string; i, Stev: integer;
begin
  Kodiran := '';
  for i := 1 to Length(Niz) do begin
    Stev := StevilkaCrke(Niz[i]) + Kljuc;
    if Stev > n then Stev := Stev - n;
    Kodiran := Kodiran + CrkaIzStevilke(Stev);
  end; {for i}
  Kodiraj := Kodiran;
end; {Kodiraj}

{ Vrne 0, e Podniza ni v Nizu, sicer pa vrne zaetni indeks prve pojavitve. }
function JePodniz(Niz, Podniz: string): integer;
var i, j: integer;
begin
  for i := 1 to Length(Niz) - Length(Podniz) +  1 do begin
    { Poglejmo, e je Podniz enak Niz[i..i + Length(Podniz) - 1]. }
    j := 0;
    while j < Length(Podniz) do 
      if Niz[i + j] = Podniz[j + 1] then j := j + 1 else break;
    { Podniz in Niz[i..i + Length(Podniz) - 1] se ujemata v prvih j znakih. }
    if j = Length(Podniz) then begin JePodniz := i; exit end;
  end; {while}
  JePodniz := 0;
end; {JePodniz}

function Dekodiraj(Kodirano, Znano: string): integer;
var k: integer; KodZnano: string;
begin
  for k := 1 to n - 1 do begin
    KodZnano := Kodiraj(Znano, k);
    if JePodniz(Kodirano, KodZnano) > 0 then 
      begin Dekodiraj := k; exit end;
  end; {for k}
  Dekodiraj := 0; { Primernega kljua sploh ni. }
end; {Dekodiraj}

{ Kot Dekodiraj, le da izpie vse mone kljue. }
function Dekodiraj2(Kodirano, Znano: string): integer;
var k, i: integer; KodZnano: string;
begin
  Dekodiraj2 := 0;
  for k := 1 to n - 1 do begin
    KodZnano := Kodiraj(Znano, k);
    i := JePodniz(Kodirano, KodZnano);
    if i > 0 then begin
      WriteLn('k = ', k, ', KodZnano = ''', KodZnano, ''' se pojavlja v Kodirano na indeksu ', i);
      Dekodiraj2 := k;
    end; {if}
  end; {for k}
end; {Dekodiraj}

var Kodirano, Znano: string; i, Kljuc: integer;
begin {CezarjevKod}
  if ParamCount >= 1 then begin Kodirano := ParamStr(1); WriteLn('Kodirani niz: ', Kodirano) end
  else begin Write('Vnesi kodirani niz: '); ReadLn(Kodirano) end;
  if ParamCount >= 2 then begin Znano := ParamStr(2); WriteLn('Znani podniz prvotnega niza: ', Znano) end
  else begin Write('Vnesi znani podniz prvotnega niza: '); ReadLn(Znano) end;
  for i := 1 to Length(Kodirano) do if not (Kodirano[i] in ['A'..'Z']) then 
    begin WriteLn('Neveljaven znak ', Ord(Kodirano[i]), ' v Kodirano[', i, '].'); Halt; end;
  for i := 1 to Length(Znano) do if not (Znano[i] in ['A'..'Z']) then 
    begin WriteLn('Neveljaven znak ', Ord(Znano[i]), ' v Znano[', i, '].'); Halt; end;
  Kljuc := Dekodiraj2(Kodirano, Znano);
  if Kljuc <= 0 then WriteLn('Ni primernega kljua!')
  else WriteLn('Primeren klju je k = ', Kljuc, '.');
end. {CezarjevKod}
